Package: COUNT
Type: Package
Title: Functions, Data and Code for Count Data
Version: 1.3.5
Date: 2025-04-27
Imports: MASS
Depends: R (>= 2.10), msme, sandwich
Authors@R: c(person(given = c("Joseph", "M"),
                      family = "Hilbe",
                      role = "aut",
                      email = "hilbe@asu.edu"),
               person(given = "Andrew",
                      family = "Robinson",
                      role = "cre",
                      email = "apro@unimelb.edu.au"))
Description: Functions, data and code for Hilbe, J.M. 2011. Negative Binomial Regression, 2nd Edition (Cambridge University Press) and Hilbe, J.M. 2014. Modeling Count Data (Cambridge University Press).
License: GPL-2
LazyLoad: yes
NeedsCompilation: no
Packaged: 2025-04-27 10:40:03 UTC; apro
Author: Joseph M Hilbe [aut],
  Andrew Robinson [cre]
Maintainer: Andrew Robinson <apro@unimelb.edu.au>
Repository: CRAN
Date/Publication: 2025-04-28 10:00:27 UTC
Built: R 4.3.3; ; 2025-04-28 11:37:08 UTC; unix

import(msme)
import(MASS)
import(sandwich)

importFrom("stats", "dnbinom", "dpois", "fitted", "model.frame",
           "model.matrix", "model.response", "optim", "pnorm",
           "rbinom", "rgamma", "rnbinom", "rnorm", "rpois", "runif")

exportPattern("^[^\\.]")

# hilbe.NBR2.F9.4.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figure 9.4     user may amend as required for own model
# Table 9.32
#
load("c://source/azpro.RData")
attach(azpro)
myTable <- function(x) {
myDF <- data.frame( table(x) )
myDF$Prop <- prop.table( myDF$Freq )
myDF$CumProp <- cumsum( myDF$Prop )
myDF
}
by(los, procedure, myTable)
windows(record=TRUE)      # set so graphs both show
by(los, procedure, hist)  # produces histograms
# OR
library("ggplot2")
qplot(los,geom="histogram",facets=procedure~.)

# hilbe.NBR2.F9.5.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# observed vs predicted number of afffairs
# Figure 9.5     user may amend as required for own model
#
load("c://source/mdvis.RData") 
poimd <- glm(numvisit ~ reform+ badh+age+educ+loginc,family=poisson, data=mdvis) 
mu <- fitted.values(poimd) 
p <- NULL 
avgp <- NULL
for (i in 0:20) { 
 p[[i+1]] <- exp(-mu)*(mu^i)/factorial(i) 
 avgp[i+1] <- mean(p[[i+1]])
} 
nCases <- dim(mdvis) 
n<- NULL 
propObs<- NULL 
probFit<- NULL 
yFitMean<- NULL 
for (i in 0:20) {                        #possible values for naffairs
bLos<- mdvis$numvisit==i                 #selector for naffairs=i 
n[i+1]<- sum(bLos)                       #number for naffairs=i 
propObs[i+1]<- n[i+1]/nCases[1]          #observed proportion for naffairs=i 
} 
Diff <- propObs*100 - avgp*100
data.frame(LOS=0:20, ObsProp=propObs*100, avgp*100, Diff)

plot(0:20, avgp, type="b", xlim=c(0,20), 
      main = "Observed vs Predicted Visits", 
      xlab = "Number Visits", ylab = "Probability of Visits")
lines(0:20, propObs, type = "b", pch = 2)
legend("topright", legend = c("Predicted Visits","Observed Visits"),
        lty = c(1,1), pch = c(1,2)) 

# nbr2_6_2_2.r  Chanages to univariable models
# Table 6.6  Hilbe,JM (2011), Negative Binomial Regression, 2 ed, Cambridge Univ Press
nobs <- 50000
x1 <- runif(nobs)
y <-rpois(nobs, exp(1 + 0.5*x1))
poi <- glm(y ~ x1, family=poisson)
summary(poi)
mu <- predict(poi, type="response")
# change response y
y10 <- y*10
poi10 <- glm(y10 ~ x1, family=poisson)
summary(poi10)
mu10 <- predict(poi10, type="response")
# change predictor x1
x10 <- x1*10
poix <- glm(y ~ x10, family=poisson)
summary(poix)
mux10 <- predict(poix, type="response")

# hilbe.NBR2.F9.2alt.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figure 9.2  Table Creation - no graphic  Alternative  
# 
rm(list=ls())
load("c://source/affairs.RData") 
affmodel <- glm.nb(naffairs~ kids + avgmarr + hapavg +  vryhap + notrel + slghtrel + smerel + vryrel + yrsmarr3 + yrsmarr4 + yrsmarr5 + yrsmarr6, data=affairs)
mu <- fitted.values(affmodel) 
avgp <- sapply(0:13, function(i) mean(exp(-mu)*(mu^i)/factorial(i)))
propObsv <- with(subset(affairs, naffairs < 14), table(naffairs) / nrow(affairs))
Diff <- c(0,propObsv)*100 - avgp[1:25]*100
data.frame(LOS=0:13, ObsProp=c(0,propObsv)*100, avgp*100, Diff)

# R script for Stata abic command
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
#  and Hilbe, Logistic Regression Models, Chapman & Hall/CRC
model  <- <insert model name>
obs    <- model$df.null + 1
aic    <- model$aic
xvars  <- model$rank
rdof   <- model$df.residual
aic_n  <- aic/obs
ll     <- xvars - aic/2
bic_r  <- model$deviance - (rdof * log(obs)
bic_l  <- -2*ll + xvars * log(obs)
bic_qh <- -2*(ll - xvars * log(xvars))/obs
aic; aic_n; bic_l; bic_qh

# syn.ppfm.r   Synthetic Poisson-Poisson Finite Mixture model
# Table 13.2: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
#
library(flexmix)
nobs <- 50000
x1 <- runif(nobs)
x2 <- runif(nobs)
xb1 <- 1 + 0.25*x1 - 0.75*x2
xb2 <- 2 + 0.75*x1 - 1.25*x2
exb1 <- exp(xb2)
exb2 <- exp(xb1)
py1 <-  rpois(nobs, exb2)
py2 <-  rpois(nobs, exb1)
poixpoi <- py2
poixpoi <- ifelse(runif(nobs) > .9, py1, poixpoi)
pxp <- flexmix(poixpoi ~ x1 + x2, k=2, 
   model=FLXMRglm(family="poisson"))
summary(pxp)
parameters(pxp, component=1, model=1)
parameters(pxp, component=2, model=1)











library(MASS)     
library(gamlss)
nobs <- 50000
x1 <- runif(nobs)
x2 <- runif(nobs)
xb <-  0.5 + 1.25*x1 - 1.5*x2     
delta <- .5      # value assigned to delta
exb <-exp(xb)
idelta <- (1/delta)*exb    
xg <-rgamma(50000, idelta, idelta, 1/idelta)
xbg <- exb*xg
nb1y <- rpois(50000, xbg)
jhgm <- gamlss(nbly ~ x1 + x2,family=NBII)
summary(jhgm)
# nb1 <- ml.nb1(los ~ hmo + white + type) # Table 10.8
# nb1

# hilbe.NBR2.F6.2.r
# Table 6.15 + added code
# Table of Poisson observed vs predicted mean counts and diffrence;  
#   graphic of observed vs predicted counts
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Table 6.15; Figure 6.2  
# User to amend default dataset, response, and number of counts
#
rm(list=ls())
load("c://source/medpar.RData")
mdpar <- glm(los ~ hmo+white+type2+type3, family=poisson, data=medpar)
mu <- fitted(mdpar)
avgp <- sapply(0:25, function(i) mean(exp(-mu)*(mu^i)/factorial(i)))
propObsv <- with(subset(medpar, los < 26), table(los) / nrow(medpar))
Diff <- c(0,propObsv)*100 - avgp[1:25]*100
data.frame(LOS=0:25, ObsProp=c(0,propObsv)*100, avgp*100, Diff)

plot(0:25, avgp, type="b", xlim=c(0,25),
main = "Observed vs Predicted Days",
xlab = "Days in Hospital", ylab = "Probability of LOS")
lines(0:25, c(0,propObsv), type = "b", pch = 2)
legend("topright", legend = c("Predicted Days","Observed Days"),
           lty = c(1,1), pch = c(1,2))

# p.reg.ml.r
# Poisson optimization  
# Ch 6.2.1 : Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
set.seed(3357)
b <- c(5, 1, 0.5)                    ## Population parameters
n <- 10000
X <- cbind(1, rnorm(n), rnorm(n))    ## Design matrix
y <- rpois(n = n, lambda = X %*% b)

p.reg.ml <- function(b.hat, X, y) {  ## Joint Conditional LL
  sum(dpois(y, lambda = X %*% b.hat, log = TRUE))  
}
p.0 <- lm.fit(X, y)$coef             ## Obtain initial estimates
fit <- optim(p.0,                    ## Maximize JCLL
             p.reg.ml,
             X = X,
             y = y,
             control = list(fnscale = -1),
             hessian = TRUE
             )
stderr <- sqrt(diag(solve(-fit$hessian))) ## Asymptotic SEs
poiresults <- data.frame(fit$par, stderr)
poiresults

# syn.poissono.r   Poisson with offset
# Table 6.20 : Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
nobs <- 50000
x1 <- runif(nobs)
x2 <- runif(nobs)
off <- rep(1:5, each=10000, times=1)*100 # offset 
loff <- log(off)                         
py <-rpois(nobs, exp(2 + .75*x1 -1.25*x2 + loff))  
poir <-glm(py ~ x1 + x2 + offset(loff), family=poisson)
summary(poir)
confint(poir)

# syn.hurdle_lnb2.r  snthetic logit-NB2 hurdle model
# Table 11.4  Hilbe,JM (2011), Negative Binomial Regression, 2 ed, Cambridge Univ Press
library(MASS)
library(pscl)
nobs <- 50000
x1 <- runif(nobs)
x2 <- runif(nobs)
xb <- 2 + .75*x1 - 1.25*x2
a <- .5
ia <- 1/.5
exb <- exp(xb)
xg <- rgamma(n = nobs, shape = a, scale = a)
xbg <-exb*xg
nby <- rpois(nobs, xbg)
nbdata <- data.frame(nby, x1, x2)
nby <- nbdata[nbdata$nby!=0, ]
pi <- 1/(1+exp(-(.9*x1 + .1*x2 + .2)))
bern <- runif(nobs)>pi
bern <- as.numeric(bern)
jhObs <- which( nbdata$bern==0 ) #  nbdata$nby <- ifelse(bern==0, 0, nbdata$nby)
nbdata$nby[jhObs] <- 0           #  hy <- nbdata$nby
hy <- nby
hlnb2 <- hurdle(hy ~ x1 + x2, dist="negbin", 
      zero.dist= "binomial", link="logit", data=nbdata)
summary(hlnb2)

# hilbe.NBR2.F14.1.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# FIGURE 14.1 
library(gamlss.mx)
load("c://source/medpar.RData")
rinb <- gamlssNP(los~ hmo +white+ type2 +type3, random=~1|provnum, 
      data=medpar, family=NBI, mixture="gq", K=20) 
summary(rinb)

summary(rinb$sigma.fv) 
m<-rinb$mu.fv       # fitted values for extended model
s<-rinb$sigma.fv    # sigma
presid <- (medpar$los-m)/sqrt(m+s*m*m) 
summary(presid)
hist(presid)

# hilbe_NBR2_F3_1.r
# Table 3.1
# Script for creating Poisson and negative binomial (NB2) distributions 
#  on single graph with user specified number of observations (obs), 
#  mean (mu), counts (0:specified), and NB2 ancillary parameter value (alpha).
#  Additional enhanced graphic can be displayed; -ggplot2- must be installed. 
#  From Hilbe, Negative Binomial Regression, 2nd ed, Cambridge Univ. Press
#  Table 3.1; Figure 3.1
#
# ------------------------------------------
# User specified values; defaults displayed
obs   <- 11
mu    <- 2
y     <- 0:10
alpha <- 1.5
# ------------------------------------------
amu <- mu*alpha
ynb2 = exp(
        y*log(amu/(1+amu)) 
     - (1/alpha)*log(1+amu) 
     + log( gamma(y +1/alpha) )
     - log( gamma(y+1) ) 
     - log( gamma(1/alpha) ) 
)
xbar = "mu"
a = "alpha"
plot(  y, ynb2, col="red", pch=5,
  main="Poisson vs Negative Binomial PDFs")
  lines( y, ynb2, col="red")
  points(y, yp2,  col="blue", pch=2)
  lines( y,  yp2, col="blue")
  legend(4.3,.40, 
    c("Negative Binomial: mean=2, a=1.5",
      "Poisson: mean=2"),
    col=( c("red","blue") ),
    pch=( c(5,2) ),
    lty=1)
#========= FOR NICER GRAPHIC =======================
zt <- 0:10           #zt is Zero to Ten
x <- c(zt,zt)        #two zt's stacked for use with ggplot2
newY <- c(yp2, ynb2) #Now stacking these two vars
Distribution <- gl(n=2,k=11,length=22,
  label=c("Poisson","Negative Binomial")
)
NBPlines <- data.frame(x,newY,Distribution)
library("ggplot2")
ggplot( NBPlines, aes(x,newY,shape=Distribution,col=Distribution ) ) +
  geom_line() + geom_point()

# hilbe.NBR2.F6.4.r
# Conditional effects Poisson plot with user specified mean values
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Table 6.17; Figure 6.4  
# User to amend data, model variables, and effects for graphing
load("c://source/rwm5yr.RData")
eppoi <- glm(docvis ~ outwork+age+female+married+edlevel2+edlevel3+ edlevel4,  family=poisson, data=rwm5yr)
rest  <- eppoi$coef[4]*mean(rwm5yr$female) + eppoi$coef[5]*mean(rwm5yr$married) +  
         eppoi$coef[6]*mean(rwm5yr$edlevel2) + eppoi$coef[7]*mean(rwm5yr$edlevel3) +  
         eppoi$coef[8]*mean(rwm5yr$edlevel4)
out0  <- eppoi$coef[1] + eppoi$coef[3]*rwm5yr$age + rest
out1  <- eppoi$coef[1] + eppoi$coef[2]*1 + eppoi$coef[3]*rwm5yr$age + rest
eout1 <- exp(out1)
eout0 <- exp(out0)
matplot(cbind(rwm5yr$age, rwm5yr$age), cbind(eout0, eout1), 
  pch=1:2, col=1:2, xlab='Count', ylab='Frequency?') 
matplot(cbind(rwm5yr$age, rwm5yr$age), cbind(eout0, eout1), type='l', 
  lty=1:2, col=1:2, xlab='Doctor visits', ylab='Frequency')

#------------------------------------------------------------------------------------------
# this is new ZAP, the Poisson Zero Adjusted distribution with extra probability for 0, in generic form 
ZAP <- function (mu.link = "log", sigma.link = "logit")
{
    mstats <- checklink("mu.link", "ZAP", substitute(mu.link),    
                           c("1/mu^2", "log", "identity"))
    dstats <- checklink("sigma.link", "ZAP", substitute(sigma.link), 
                           c("logit", "probit", "cloglog", "cauchit", "log", "own"))   
    structure(
          list(family = c("ZAP", "Poisson Zero Inflated"),
           parameters = list(mu=TRUE, sigma=TRUE), 
                nopar = 2, 
                 type = "Discrete",
              mu.link = as.character(substitute(mu.link)),  
           sigma.link = as.character(substitute(sigma.link)), 
           mu.linkfun = mstats$linkfun, 
        sigma.linkfun = dstats$linkfun, 
           mu.linkinv = mstats$linkinv, 
        sigma.linkinv = dstats$linkinv,
                mu.dr = mstats$mu.eta, 
             sigma.dr = dstats$mu.eta, 
     dldm = function(y,mu,sigma) {dldm0 <- PO()$dldm(y,mu) + dPO(0,mu)*PO()$dldm(0,mu)/(1-dPO(0,mu))
                         dldm <- ifelse(y==0, 0 , dldm0)
                         dldm}, 
    d2ldm2 = function(y,mu,sigma) {dldm0 <- PO()$dldm(y,mu) + dPO(0,mu)*PO()$dldm(0,mu)/(1-dPO(0,mu))
                          dldm <- ifelse(y==0, 0 , dldm0)
                        d2ldm2 <- -dldm*dldm
                         d2ldm2},
     dldd = function(y,mu,sigma) {dldd <- ifelse(y==0, 1/sigma, -1/(1-sigma))
                         dldd}, 
    d2ldd2 = function(y,mu,sigma) {d2ldd2 <- -1/(sigma*(1-sigma))
                         d2ldd2},
  d2ldmdd = function(y,mu,sigma) {d2ldmdd <- 0
                      d2ldmdd                        
                       },
 G.dev.incr  = function(y,mu,sigma,...) -2*dZAP(y,mu,sigma,log=TRUE),                      

         rqres = expression(rqres(pfun="pZAP", type="Discrete", ymin=0, y=y, mu=mu, sigma=sigma)) ,
    mu.initial = expression(mu <- (y+mean(y))/2),     #rep(mean(y),length(y)) ), 

   sigma.initial = expression(sigma <-rep(0.3, length(y))), 
      mu.valid = function(mu) all(mu > 0) , 
   sigma.valid = function(sigma)  all(sigma > 0 & sigma < 1), 
       y.valid = function(y)  all(y >= 0)
          ),
            class = c("gamlss.family","family"))
}
#------------------------------------------------------------------------------------------
dZAP<-function(x, mu = 5, sigma = 0.1, log = FALSE)
 { 
          if (any(mu <= 0) )  stop(paste("mu must be greater than 0", "\n", ""))           

          if (any(sigma <= 0) | any(sigma >= 1) )  stop(paste("sigma must be between 0 and 1", "\n", "")) 
          if (any(x < 0) )  stop(paste("x must be 0 or greater than 0", "\n", ""))   
          logfy <- rep(0, length(x))
          logfy <- ifelse((x==0), log(sigma), log(1-sigma) + dPO(y,mu,log=T) - log(1-dPO(0,mu)) )          
          if(log == FALSE) fy <- exp(logfy) else fy <- logfy
          fy
  }
#------------------------------------------------------------------------------------------
pZAP <- function(q, mu = 5, sigma = 0.1, lower.tail = TRUE, log.p = FALSE)
  {     
         if (any(mu <= 0) )  stop(paste("mu must be greater than 0", "\n", ""))           

         if (any(sigma <= 0) | any(sigma >= 1) )  stop(paste("sigma must be between 0 and 1", "\n", "")) 
         if (any(q < 0) )  stop(paste("y must be 0 or greater than 0", "\n", ""))  
         cdf <- rep(0,length(q))
         cdf1 <- ppois(q, lambda = mu, lower.tail = TRUE, log.p = FALSE)
         cdf2 <- ppois(0, lambda = mu, lower.tail = TRUE, log.p = FALSE)
         cdf3 <- sigma+((1-sigma)*(cdf1-cdf2)/(1-cdf2))
         cdf <- ifelse((q==0),sigma,  cdf3)
         if(lower.tail == TRUE) cdf <- cdf else cdf <-1-cdf
         if(log.p==FALSE) cdf <- cdf else cdf <- log(cdf)    
         cdf
   }
#-----------------------------------------------------------------------------------------
qZAP <- function(p, mu = 5, sigma = 0.1, lower.tail = TRUE, log.p = FALSE)
  {      
         if (any(mu <= 0) )  stop(paste("mu must be greater than 0", "\n", ""))           

         if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0", "\n", "")) 
         if (any(p <= 0) | any(p >= 1))  stop(paste("p must be between 0 and 1", "\n", "")) 
         if (log.p == TRUE) p <- exp(p)   else p <- p
         if (lower.tail == TRUE)  p <- p  else p <- 1 - p
          pnew  <- (p-sigma)/(1-sigma)
          pnew2 <- ppois(0, lambda = mu, lower.tail = TRUE, log.p = FALSE)*(1-pnew) + pnew 
          suppressWarnings(q <- ifelse((pnew > 0 ), qpois(pnew2, lambda = mu, ), 0))
          q
   }
#-----------------------------------------------------------------------------------------
rZAP <- function(n, mu=5, sigma=0.1)
  { 
    if (any(mu <= 0) )  stop(paste("mu must greated than 0", "\n", ""))           

    if (any(sigma <= 0) )  stop(paste("sigma must greated than 0", "\n", "")) 
    if (any(n <= 0))  stop(paste("n must be a positive integer", "\n", ""))  
          n <- ceiling(n)
          p <- runif(n)
          r <- qZAP(p, mu = mu, sigma = sigma)
          r
  }
#-----------------------------------------------------------------------------------------

# hilbe.NBR2.F6.3.r
# Table 6.16
# Graphic of Poisson distributions with user specified mean values
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Table 6.16; Figure 6.3  
# 
m<- c(0.5,1,3,5,7,9) #Poisson means 
y<- 0:19             #Observed counts 
layout(1) 
for (i in 1:length(m)) { 
  p<- dpois(y, m[i]) #poisson pmf 
  if (i==1) { 
  plot(y, p, col=i, type='l', lty=i) 
  } else { 
  lines(y, p, col=i, lty=i) 
  } 
}

# nbr2_7_1.r   
# Table 7.1: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
# Poisson with frequency table of observed counts

library(MASS)         
nobs <- 50000
x1 <- runif(nobs)
x2 <- runif(nobs)
x3 <- runif(nobs)
py <-rpois(nobs, exp(1 + 0.5*x1 - 0.75*x2 + 0.25*x3))
cnt <-  table(py)
df <- data.frame( prop.table( table(py) ) )
df$cumulative <- cumsum( df$Freq )
dfall <- data.frame(cnt, df$Freq, df$cumulative)
dfall

# syn.nbc.r 
# Table 10.9: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
#     with assistance of: Andrew Robinson, University of Melbourne, Australia
# Synthetic NB-C estimated using optimiation
#
library(MASS)
nobs <- 50000
x2 <- runif(nobs)
x1 <- runif(nobs)
a <- 1.15            # value of alpha: 1.15               
xb <- 1.25*x1 + .1*x2 - 1.5   
mu <- 1/((exp(-xb)-1)*a)
p <- 1/(1+a*mu)
r <- 1/a
nbcy <- rnbinom(50000, size=r, prob = p)

nbc.reg.ml <- function(b.hat, X, y) {
 a.hat <- b.hat[1]
 xb.hat <- X %*% b.hat[-1]
 mu.hat <- 1 / ((exp(-xb.hat)-1)*a.hat)
 p.hat <- 1 / (1 + a.hat*mu.hat)
 r.hat <- 1 / a.hat
 sum(dnbinom(y,
             size = r.hat,
             prob = p.hat,
             log = TRUE))
}
nbcX <- cbind(1, x1, x2)
 p.0 <- c(a.hat = 1,
        b.0 = -2,
        b.1 = 1,
        b.2 = 1)

fit <- optim(p.0,        ## Maximize the JCLL
            nbc.reg.ml,
            X = nbcX,
            y = nbcy,
            control = list(fnscale = -1),
            hessian = TRUE
            )
fit$par                      ## ML estimates
sqrt(diag(solve(-fit$hessian)))   ## SEs

# syn.nb2.r   Synthetic NB2
# Table 9.3: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
library(MASS)                 
nobs <- 50000
x1 <- qnorm(runif(nobs))      # random normal N[0,1] variate
x2 <- qnorm(runif(nobs))      # random normal N[0,1] variate
xb <- 2 + .75*x1 - 1.25*x2    # parameter values
a <- .5                       # assign value to ancillary parameter
ia <- 1/.5                    # invert alpha
exb <- exp(xb)                # Poisson predicted value
xg <- rgamma(n = nobs, shaep = a, rate = a)  # generate gamma variates given alpha
xbg <-exb*xg                  # mix Poisson and gamma variates
nby <- rpois(nobs, xbg)       # generate NB2 variates
jhnb2 <-glm.nb(nby ~ x1 + x2) # model NB2
summary(jhnb2)

# nb.reg.ml.r  
# Synthetic MLE Negative Binomial NB2 data and model 
# Table 9.11: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
#     with assistance of: Andrew Robinson, University of Melbourne, Australia
#
set.seed(85132)
b <- c(5, 2, 3, 0.5)             ## Population parameters
n <- 10000
X <- cbind(rlnorm(n), rlnorm(n)) ## Design matrix
y <- rnbinom(n = n,              ## Choice of parameterization
             mu = b[1] + b[2] * X[,1],
             size = b[3] + b[4] * X[,2])
nb.reg.ml <- function(b.hat, X, y) {  ## JCLL
  sum(dnbinom(y,
              mu = b.hat[1] + b.hat[2] * X[,1],
              size = b.hat[3] + b.hat[4] * X[,2],
              log = TRUE))  
}
p.0 <- c(1,1,1,1)                ## initial estimates
fit <- optim(p.0,                ## Maximize the JCLL
             nb.reg.ml,
             X = X,
             y = y,
             control = list(fnscale = -1),
             hessian = TRUE
             )
stderr <- sqrt(diag(solve(-fit$hessian))) ## Asymptotic SEs
nbresults <- data.frame(fit$par, stderr)
nbresults

# hilbe.NBR2.F9.2.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figure 9.2     user may amend as required for own model
# 
load("c://source/affairs.RData") 
affmodelnb <- glm.nb(naffairs~ kids + avgmarr + hapavg +  vryhap + notrel + slghtrel + smerel + vryrel + yrsmarr3 + yrsmarr4 + yrsmarr5 + yrsmarr6, data=affairs) 
mu <- fitted.values(affmodelnb) 
p <- NULL 
avgp <- NULL
for (i in 0:15) { 
 p[[i+1]] <- exp(-mu)*(mu^i)/factorial(i) 
 avgp[i+1] <- mean(p[[i+1]])
} 
nCases <- dim(affairs) 
n<- NULL 
propObs<- NULL 
probFit<- NULL 
yFitMean<- NULL 
for (i in 0:15) {                        #possible values for naffairs
bLos<- affairs$naffairs==i               #selector for naffairs=i 
n[i+1]<- sum(bLos)                       #number for naffairs=i 
propObs[i+1]<- n[i+1]/nCases[1]          #observed proportion for naffairs=i 
} 
Diff <- propObs*100 - avgp*100
data.frame(LOS=0:15, ObsProp=propObs*100, avgp*100, Diff)

plot(0:15, avgp, type="b", xlim=c(0,15), 
      main = "Observed vs Predicted Affairs", 
      xlab = "Number Affairs", ylab = "Probability of naffairs")
lines(0:15, propObs, type = "b", pch = 2)
legend("topright", legend = c("Predicted Affairs","Observed Affairs"),
        lty = c(1,1), pch = c(1,2))  

# hilbe.NBR2.F9.3.r
# Negative binomial regression postestimation graphic 
#    Standardized deviance vs fitted value, mu.  
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figure 9.3     user may amend as required for own model
#
load("c://source/affairs.RData")
affnb2r <-  glm.nb(naffairs~ avgmarr + hapavg + vryhap + smerel 
     + vryrel + yrsmarr4 + yrsmarr5 + yrsmarr6, data=affairs) 
summary(affnb2r)
confint(affnbr2)
exp(coef(affnb2r))
exp(confint(affnb2r))
deviance <- residuals(affnb2, type="deviance")
dev <- sum(deviance*deviance)
pred <- predict(affnb2, se.fit=TRUE, type="response")
mu <- pred$fit
stdp <- pred$se.fit                 # Std error of prediction
variance <- mu 
h <- stdp * stdp*variance           # hat matrix diagonal
sdeviance <- rstandard(affnb2)      # Std deviance
plot(mu, sdeviance)

# hilbe.NBR2.F9.1.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figure 9.1     user may amend as required for own model
# 
load("c://source/affairs.RData") 
affmodel <- glm(naffairs~ kids + avgmarr + hapavg +  vryhap + notrel + slghtrel + smerel + vryrel + yrsmarr3 + yrsmarr4 + yrsmarr5 + yrsmarr6, family=poisson, data=affairs)
mu <- fitted(affmodel) 
p <- NULL 
avgp <- NULL
for (i in 0:15) { 
 p[[i+1]] <- exp(-mu)*(mu^i)/factorial(i) 
 avgp[i+1] <- mean(p[[i+1]])
} 
nCases <- dim(affairs) 
n<- NULL 
propObs<- NULL 
probFit<- NULL 
yFitMean<- NULL 
for (i in 0:15) {                        #possible values for naffairs
bLos<- affairs$naffairs==i               #selector for naffairs=i 
n[i+1]<- sum(bLos)                       #number for naffairs=i 
propObs[i+1]<- n[i+1]/nCases[1]          #observed proportion for naffairs=i 
} 
Diff <- propObs*100 - avgp*100
data.frame(LOS=0:15, ObsProp=propObs*100, avgp*100, Diff)

plot(0:15, avgp, type="b", xlim=c(0,15), 
      main = "Observed vs Predicted Affairs", 
      xlab = "Number Affairs", ylab = "Probability of naffairs")
lines(0:15, propObs, type = "b", pch = 2)
legend("topright", legend = c("Predicted Affairs","Observed Affairs"),
        lty = c(1,1), pch = c(1,2))  

# syn.nb2o.r     Synthetic NB2 with offset
# Table 9.9: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
library(MASS)
x1 <- qnorm(runif(50000))
x2 <- qnorm(runif(50000))
off <- rep(1:5, each=10000, times=1)*100  # offset 
loff <- log(off)                          # log of offset
xb<-2 + .75*x1 -1.25*x2 + loff            # linear predictor
exb <-exp(xb)                  # inverse link
a <- .5                        # assign value to alpha
ia <- 1/.5                     # invert alpha
xg <- rgamma(n = 50000, shape = a, rate = a)  # generate gamma variates w alpha
xbg <-exb*xg                   # mix Poisson and gamma variates
nbyo <- rpois(50000, xbg)      # generate NB2 variates - w offset
nb2o <-glm.nb(nbyo ~ x1 + x2 + offset(loff))  # model NB2
summary(nb2o)

# hilbe.NBR2.F6.2alt.r
# Table 6.15 + added code
# Table of Poisson observed vs predicted mean counts and diffrence;  
#   graphic of observed vs predicted counts
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Table 6.15; Figure 6.2  Alternative
# User to amend default dataset, response, and number of counts
#
load("c://source/medpar.RData") 
mdpar <- glm(los ~ hmo+white+type2+type3,family=poisson, data=medpar) 
mu <- fitted.values(mdpar) 
p <- NULL 
avgp <- NULL
for (i in 0:25) { 
 p[[i+1]] <- exp(-mu)*(mu^i)/factorial(i) 
 avgp[i+1] <- mean(p[[i+1]])
} 
nCases <- dim(medpar) 
n<- NULL 
propObs<- NULL 
probFit<- NULL 
yFitMean<- NULL 
for (i in 0:25) {                  #possible values for LOS 
bLos<- medpar$los==i               #selector for los=i 
n[i+1]<- sum(bLos) #number for los=i 
propObs[i+1]<- n[i+1]/nCases[1]    #observed proportion for LOS=i 
} 
Diff <- propObs*100 - avgp*100
data.frame(LOS=0:25, ObsProp=propObs*100, avgp*100, Diff)

# syn.logit.r     Synthetic logistic regression
# Table 9.20: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
library(MASS)
nobs <- 50000                           
x1 <- runif(nobs)                       
x2 <- runif(nobs)                       
xb <- 2 + .75*x1 - 1.25*x2                 # linear predictor 
exb <- 1/(1+exp(-xb))                      # fit; predicted prob
by  <- rbinom(nobs, size = 1, prob =exb)   # random logit variates
lry <- glm(by ~ x1 + x2, family=binomial(link="logit"))
summary(lry)                            

# hilbe.NBR2.F8.5.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Negative binomial regression distributions with 
#    user specified series of alpha values for a specified mean value
# Figures 8.5   default: means at 0.5, 1, 2, 5, 10 and alpha=1.5
#
obs <- 11
mu <- c(0.5,1,2,5,10)
y <- 0:10
alpha <- 1.5
amu <- mu*alpha
layout(1) 
for (i in 1:length(mu)) { 
ynb2 = exp(
        y*log(amu[i]/(1+amu[i])) 
     - (1/alpha)*log(1+amu[i]) 
     + log( gamma(y +1/alpha) )
     - log( gamma(y+1) ) 
     - log( gamma(1/alpha) ) 
)
if (i==1) { 
plot(y, ynb2, col=i, type='l', lty=i) 
  } else { 
  lines(y, ynb2, col=i, lty=i) 
  } 
}

# modelfit function to calc AIC and BIC statistics post estimation
# Joseph M. Hilbe 12January, 2010
modelfit  <- function(x)  {
obs    <- x$df.null + 1
aic    <- x$aic
xvars  <- x$rank
rdof   <- x$df.residual
aic_n  <- aic/obs
ll     <- xvars - aic/2
bic_r  <- x$deviance - (rdof * log(obs))
bic_l  <- -2*ll + xvars * log(obs)
bic_qh <- -2*(ll - xvars * log(xvars))/obs
return(list("AIC" = aic, "AICn" = aic_n, "BIC" = bic_l, "BICqh" = bic_qh))
}
modelfit(x)  # substitute fitted model name for x

# nbsim.r   
# Table 9.5: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
# Synthetic NB2 Monte Carlo estimation
#
library(MASS)
mysim <- function()
{
 nobs <- 50000
 x1 <-runif(nobs)
 x2 <-runif(nobs)
 xb <- 2 + .75*x1 - 1.25*x2
 a <- .5                        
ia <- 1/.5                     
exb <- exp(xb)                 
xg <- rgamma(n = nobs, shape = a, rate = a)
xbg <-exb*xg                   
nby <- rpois(nobs, xbg)       
nbsim <-glm.nb(nby ~ x1 + x2)  
   alpha <- nbsim$theta 
   pr <- sum(residuals(nbsim, type="pearson")^2)
   prdisp <- pr/nbsim$df.residual
   beta <- nbsim$coef
   list(alpha,prdisp,beta)
}
B <- replicate(100, mysim())   
mean(unlist(B[1,]))
mean(unlist(B[2,]))
apply(matrix(unlist(B[3,]),3,100),1,mean)

# hilbe.NBR2.F8.1.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Negative binomial regression distributions with 
#    user specified series of alpha values for a specified mean value
# Figure 8.2-6   default: means at .5, 1, 2, 5, 10 and alpha=0
#
m<- c(0.5,1,2,5,10)  #mean values 
y<- 0:10             #Observed counts 
layout(1) 
for (i in 1:length(m)) { 
  p<- dpois(y, m[i]) #poisson pmf 
  if (i==1) { 
  plot(y, p, col=i, type='l', lty=i) 
  } else { 
  lines(y, p, col=i, lty=i) 
  } 
}

# syn.geo.r     Synthetic log-geometric regression
# Table 10.4: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
library(MASS)
nobs <- 50000
x2 <- runif(nobs)
x1 <- runif(nobs)
xb <- 2*x1 - .5*x2 - 1   
exb <- exp(xb)               
xg <- rgamma(n = nobs, shape = 1, rate = 1) 
xbg <-exb*xg                 
gy <- rpois(nobs, xbg)      
gnb2 <-glm.nb(gy ~ x1 + x2)   
summary(gnb2)
gpy <- glm(gy ~ x1 + x2, family=poisson)
summary(gpy)

rm(list=ls())
load("c://source/medpar.RData")
medpar$type <- factor(medpar$type)

nbc.reg.ml <- function(b.hat, X, y) {
  a.hat <- b.hat[1]
  xb.hat <- X %*% b.hat[-1]
  mu.hat <- 1 / ((exp(-xb.hat)-1)*a.hat)
  p.hat <- 1 / (1 + a.hat*mu.hat)
  r.hat <- 1 / a.hat
  sum(dnbinom(y,
              size = r.hat,
              prob = p.hat,
              log = TRUE))                           
}  
# Create the design matrix
nbcX <- model.matrix(~ hmo + white + type, data = medpar)

# Starting points (discovered by trial and error!)
p.0 <- c(alpha = 0.5,
         cons = -1,
         hmo = 0,
         white = 0,
         type2 = 0,
         type3 = 0)

# Maximize the joint conditional LL
nbc.fit <- optim(p.0,             
                 nbc.reg.ml,
                 X = nbcX,
                 y = medpar$los,
                 control = list(
                   fnscale = -1,
                   maxit = 10000),
                 hessian = TRUE
                 )

# and obtain the parameter estimates and asymptotic SE's by 
(nbc.beta.hat <- nbc.fit$par)
(nbc.se.beta.hat <- sqrt(diag(solve(-nbc.fit$hessian))))
nbc.results <- data.frame(Estimate = nbc.beta.hat,
                          SE = nbc.se.beta.hat,
                          Z = nbc.beta.hat / nbc.se.beta.hat,
                          LCL = nbc.beta.hat - 1.96 * nbc.se.beta.hat,
                          UCL = nbc.beta.hat + 1.96 * nbc.se.beta.hat)
rownames(nbc.results) <- c("alpha", colnames(nbcX))
nbc.results <- nbc.results[c(2:nrow(nbc.results), 1),]
nbc.results

# hilbe.NBR2.F9.6ab.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# mu vs standardized deviance graphs
# Figure 9.6a and 9.6b     user may amend as required for own model
# Table 9.46  
#
# mu and Std deviance from ex4poie in T 9.44 - Poisson model
deviancep <- residuals(ex4poie, type="deviance")
devp <- sum(deviancep*deviancep)
predp <- predict(ex4poie, se.fit=TRUE, type="response")
mup <- predp$fit
mup <- 2*sqrt(mup)
stdpp <- predp$se.fit                 # Std error of prediction
variancep <- mup 
hp <- stdpp * stdpp*variancep           # hat matrix diagonal
sdeviancep <- rstandard(ex4poie)      # Std deviance
plot(mup, sdeviancep)
# mu and Std deviance from ex4nbe in T 9.45 - NB2 model
deviancenb <- residuals(ex4nbe, type="deviance")
devnb <- sum(deviancenb*deviancenb)
prednb <- predict(ex4nbe, se.fit=TRUE, type="response")
munb <- prednb$fit
munb <- 2*sqrt(munb)
stdpnb <- prednb$se.fit                 # Std error of prediction
variancenb <- munb 
hnb <- stdpnb * stdpnb*variancenb     
sdeviancenb <- rstandard(ex4nbe)       # Std dev 
plot(munb, sdeviancenb)                # Figure 9.6B

# mysim.r  
# Table 6.5 : Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
#  Monte Carlo simulation - Poisson
mysim <- function()
{
 nobs <- 50000
 x1 <-runif(nobs)
 x2 <-runif(nobs)
py <- rpois(nobs, exp(2 + .75*x1 - 1.25*x2))       
poi <- glm(py ~ x1 + x2, family=poisson)  
   pr <- sum(residuals(poi, type="pearson")^2)
   prdisp <- pr/poi$df.residual
   beta <- poi$coef
   list(beta,prdisp)
}
B <- replicate(100, mysim())   
apply(matrix(unlist(B[1,]),3,100),1,mean)
mean(unlist(B[2,]))

# ---------------------------------------------------------------------------------------
# zero inflated negative binomial type I (with probability y=0 is nu) 01/03/10
# ---------------------------------------------------------------------------------------
ZINBI = function (mu.link = "log", sigma.link = "log", nu.link = "logit") 
{
    mstats <- checklink("mu.link", "ZINBI", substitute(mu.link), 
        c("inverse", "log", "identity"))
    dstats <- checklink("sigma.link", "ZINBI", substitute(sigma.link), 
        c("inverse", "log", "identity"))
    vstats <- checklink("nu.link", "ZINBI", substitute(nu.link), 
        c("logit", "probit", "cloglog", "log", "own"))

    structure(list(family = c("ZINBI", "Zero inflated negative binomial type I"),
               parameters = list(mu = TRUE, sigma = TRUE, nu = TRUE),
                    nopar = 3,
                     type = "Discrete",
                  mu.link = as.character(substitute(mu.link)),
               sigma.link = as.character(substitute(sigma.link)), 
                  nu.link = as.character(substitute(nu.link)),
               mu.linkfun = mstats$linkfun, 
            sigma.linkfun = dstats$linkfun,
               nu.linkfun = vstats$linkfun, 
               mu.linkinv = mstats$linkinv,
            sigma.linkinv = dstats$linkinv, 
               nu.linkinv = vstats$linkinv,
                    mu.dr = mstats$mu.eta,
                 sigma.dr = dstats$mu.eta, 
                    nu.dr = vstats$mu.eta,
                  dldm = function(y,mu,sigma,nu) {dldm0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldm(0,mu,sigma)
                         dldm <- ifelse(y==0, dldm0, NBI()$dldm(y,mu,sigma))
                         dldm}, 
               d2ldm2 = function(y,mu,sigma,nu) {dldm0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldm(0,mu,sigma)
                          dldm <- ifelse(y==0, dldm0, NBI()$dldm(y,mu,sigma))
                        d2ldm2 <- -dldm*dldm
                         d2ldm2 <- ifelse(d2ldm2 < -1e-15, d2ldm2,-1e-15)    
                        d2ldm2},
                 dldd = function(y,mu,sigma,nu) {dldd0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldd(0,mu,sigma)
                         dldd <- ifelse(y==0, dldd0, NBI()$dldd(y,mu,sigma))
                         dldd}, 
               d2ldd2 = function(y,mu,sigma,nu) {dldd0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldd(0,mu,sigma)
                         dldd <- ifelse(y==0, dldd0, NBI()$dldd(y,mu,sigma))
                  d2ldd2 <- -dldd^2  
                  d2ldd2 <- ifelse(d2ldd2 < -1e-15, d2ldd2,-1e-15)  
                  d2ldd2}, 
                 dldv = function(y,mu,sigma,nu) {dldv0 <- ((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*(1-dNBI(0,mu,sigma))
                         dldv <- ifelse(y==0, dldv0, -1/(1-nu))
                         dldv}, 
               d2ldv2 = function(y,mu,sigma,nu) {dldv0 <- ((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*(1-dNBI(0,mu,sigma))
                         dldv <- ifelse(y==0, dldv0, -1/(1-nu))      
              d2ldv2 <- -dldv^2
              d2ldv2 <- ifelse(d2ldv2 < -1e-15, d2ldv2,-1e-15)  
              d2ldv2},
        d2ldmdd = function(y) {dldm0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldm(0,mu,sigma)
                         dldm <- ifelse(y==0, dldm0, NBI()$dldm(y,mu,sigma))
                         dldd0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldd(0,mu,sigma)
                         dldd <- ifelse(y==0, dldd0, NBI()$dldd(y,mu,sigma))
                         d2ldm2<--dldm*dldd
                         d2ldm2}, 
                 d2ldmdv = function(y) {  #partial derivate of log-density respect to mu and alpha
        dldm0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldm(0,mu,sigma)
                         dldm <- ifelse(y==0, dldm0, NBI()$dldm(y,mu,sigma))
               dldv0 <- ((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*(1-dNBI(0,mu,sigma))
                         dldv <- ifelse(y==0, dldv0, -1/(1-nu))          
            d2ldmdv <- -dldm*dldv
            d2ldmdv
        },
        
        d2ldddv = function(y) {   #partial derivate of log-density respect to sigma and alpha
dldd0 <- (1-nu)*((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*dNBI(0,mu,sigma)*NBI()$dldd(0,mu,sigma)
                         dldd <- ifelse(y==0, dldd0, NBI()$dldd(y,mu,sigma))
               dldv0 <- ((nu+(1-nu)*dNBI(0,mu,sigma))^(-1))*(1-dNBI(0,mu,sigma))
                         dldv <- ifelse(y==0, dldv0, -1/(1-nu))            
            d2ldddv <- -dldd*dldv
            d2ldddv
        },        
        G.dev.incr  = function(y,mu,sigma,...) -2*dZINBI(y, mu = mu, sigma = sigma, nu=nu, log = TRUE), 
        rqres = expression(
                          rqres(pfun="pZINBI", type="Discrete", ymin=0, y=y, mu=mu, sigma=sigma)
                                 ), 
           mu.initial = expression(mu <- (y + mean(y))/2),            
##           mu.initial = expression(mu <-  y+0.5),
         sigma.initial = expression(
                      sigma <- rep( max( ((var(y)-mean(y))/(mean(y)^2)),0.1),length(y))),
           nu.initial = expression(nu <- rep(0.3, length(y))),
              mu.valid = function(mu) all(mu > 0) , 
           sigma.valid = function(sigma)  all(sigma > 0), 
             nu.valid = function(nu) all(nu > 0 & nu < 1),           
               y.valid = function(y)  all(y >= 0)
          ),
            class = c("gamlss.family","family"))
}
#-------------------------------------------------------------------------------------------
dZINBI<-function(x, mu = 1, sigma = 1, nu = 0.3, log = FALSE)
 { 
        if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
        if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", "")) 
        if (any(nu <= 0)|any(nu >= 1))  stop(paste("nu must be between 0 and 1 ", "\n", ""))
        if (any(x < 0) )  stop(paste("x must be >=0", "\n", ""))  
        if (length(sigma)>1) fy <- ifelse(sigma>0.0001, dnbinom(x, size=1/sigma, mu = mu, log = T), 
                                          dPO(x, mu = mu, log = T) )
        else fy <- if (sigma<0.0001) dPO(x, mu = mu, log = T) 
                   else dnbinom(x, size=1/sigma, mu = mu, log = T)
          logfy <- rep(0, length(x))
          logfy <- ifelse((x==0), log(nu+(1-nu)*exp(fy)), (log(1-nu) + fy ))          

          if(log == FALSE) fy2 <- exp(logfy) else fy2 <- logfy
          fy2
  }
#------------------------------------------------------------------------------------------
pZINBI <- function(q, mu = 1, sigma = 1, nu = 0.3, lower.tail = TRUE, log.p = FALSE)
  {     
        if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
        if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", "")) 
        if (any(nu <= 0)|any(nu >= 1))  #In this parametrization  nu = alpha
                    stop(paste("nu must be between 0 and 1 ", "\n", ""))
        if (any(q < 0) )  stop(paste("y must be >=0", "\n", ""))
        if (length(sigma)>1) cdf <- ifelse(sigma>0.0001, pnbinom(q, size=1/sigma, mu=mu), 
                                          ppois(q, lambda = mu) )
        else cdf <- if (sigma<0.0001) ppois(q, lambda = mu)
                   else pnbinom(q, size=1/sigma, mu=mu)
         cdf <- nu + (1-nu)*cdf
         if(lower.tail == TRUE) cdf <- cdf else cdf <-1-cdf
         if(log.p==FALSE) cdf <- cdf else cdf <- log(cdf)    
         cdf
   }
#------------------------------------------------------------------------------------------
qZINBI <- function(p, mu = 1, sigma = 1, nu = 0.3, lower.tail = TRUE, log.p = FALSE)
  {      
          if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
          if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", ""))
          if (any(nu <= 0)|any(nu >= 1))  #In this parametrization  nu = alpha
                     stop(paste("nu must be between 0 and 1 ", "\n", ""))
          if (any(p < 0) | any(p > 1))  stop(paste("p must be between 0 and 1", "\n", ""))    
          if (log.p == TRUE) p <- exp(p)   else p <- p
          if (lower.tail == TRUE)  p <- p  else p <- 1 - p
          pnew <- (p-nu)/(1-nu)
          pnew <- ifelse((pnew > 0 ),pnew, 0)
          if (length(sigma)>1) q <- ifelse(sigma>0.0001,  qnbinom(pnew, size=1/sigma, mu=mu, lower.tail=lower.tail, log.p=log.p), 
                                          qpois(pnew, lambda = mu, lower.tail = lower.tail, log.p = log.p) )
          else q <- if (sigma<0.0001) qpois(pnew, lambda = mu, lower.tail = lower.tail, log.p = log.p)
                   else qnbinom(pnew, size=1/sigma, mu=mu, lower.tail=lower.tail, log.p=log.p)
           # q2 <- suppressWarnings(ifelse((pnew > 0 ), q, 0))
#          suppressWarnings(q <- ifelse((pnew > 0 ), qpois(pnew, lambda = mu, ), 0))
          q
   }
#------------------------------------------------------------------------------------------
rZINBI <- function(n, mu = 1, sigma = 1, nu = 0.3)
  { 
          if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
          if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", "")) 
          if (any(nu <= 0)|any(nu >= 1))  #In this parametrization  nu = alpha
          stop(paste("nu must be between 0 and 1 ", "\n", ""))
          if (any(n <= 0))  stop(paste("n must be a positive integer", "\n", ""))  
          n <- ceiling(n)
          p <- runif(n)
          r <- qZINBI(p, mu=mu, sigma=sigma, nu=nu)
          r
  }
#------------------------------------------------------------------------------------------

# NB1 maximum likelihood function  J Hilbe 11Apr 2010
ml.nb1 <- function(formula, data, start = NULL, verbose = FALSE) {
  mf <- model.frame(formula, data)
  mt <- attr(mf, "terms")
  y <- model.response(mf, "numeric")
  nb1X <- model.matrix(formula, data = data)
  nb1.reg.ml <- function(b.hat, X, y) {
    a.hat <- b.hat[1]
    xb.hat <- X %*% b.hat[-1]
    mu.hat <- exp(xb.hat)
    r.hat <- (1/a.hat) * mu.hat    
    sum(dnbinom(y,
                size = r.hat,
                mu = mu.hat,
                log = TRUE))
    }
  if (is.null(start))
    start <- c(0.5, -1, rep(0, ncol(nb1X) - 1))
  fit <- optim(start,           
               nb1.reg.ml,
               X = nb1X,
               y = y,
               control = list(
                 fnscale = -1,
                 maxit = 10000),
               hessian = TRUE
               )
  if (verbose | fit$convergence > 0) print(fit)
  beta.hat <- fit$par
  se.beta.hat <- sqrt(diag(solve(-fit$hessian)))
  results <- data.frame(Estimate = beta.hat,
                        SE = se.beta.hat,
                        Z = beta.hat / se.beta.hat,
                        LCL = beta.hat - 1.96 * se.beta.hat,
                        UCL = beta.hat + 1.96 * se.beta.hat)
  rownames(results) <- c("alpha", colnames(nb1X))
  results <- results[c(2:nrow(results), 1),]
  return(results)
}

load("c://source/medpar.RData")
medpar$type <- factor(medpar$type)
med.nb1 <- ml.nb1(los ~ hmo + white + type, data = medpar)
med.nb1

binegbin.glm=function(y1,y2,x1,x2){
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# author: Masakazu Iwasaki, Clinical Statistics Group, Schering-Plough K.K., Tokyo
# 
n=length(y1)
p1=ncol(x1)
p2=ncol(x2)
p=p1+p2
print(p)
eta1=eta(y1)
eta2=eta(y2)

beta1=qr.solve(t(x1)%*%x1)%*%t(x1)%*%eta1
beta2=qr.solve(t(x2)%*%x2)%*%t(x2)%*%eta2
beta=rbind(beta1,beta2)
print(beta)
mu1=inveta(x1%*%beta1)
mu2=inveta(x2%*%beta2)

# initial value
phi=sum((y1-mu1)^2+(y2-mu2)^2-(mu1+mu2))/sum(mu1^2+mu2^2)
alpha=sum((y1-mu1)*(y2-mu2))/(phi*sum(mu1*mu2))

for(j in 1:100){
FI=matrix(0,p,p)
Q=matrix(0,p,1)

for(i in 1:n){
xi1=c(x1[i,],rep(0,p2))
xi2=c(rep(0,p1),x2[i,])
xi=cbind(xi1,xi2)
yi=c(y1[i],y2[i])
mui=c(mu1[i],mu2[i])

#phii=((y1[i]-mu1[i])^2+(y2[i]-mu2[i])^2-(mu1[i]+mu2[i]))/(mu1[i]^2+mu2[i]^2)
#alphai=c(y1[i]-mu1[i])*(y2[i]-mu2[i])/(phii*mu1[i]*mu2[i])

fi=detadmu(mui)
FI=FI+xi%*%qr.solve(fi%*%sigma(mui,phi,alpha)%*%fi,tol=1e-20)%*%t(xi)
Q=Q+xi%*%qr.solve(sigma(mui,phi,alpha)%*%fi,tol=1e-20)%*%(yi-mui)
}

dbeta=qr.solve(FI,tol=1e-20)%*%Q
beta=beta+dbeta
beta1=beta[1:p1]
beta2=beta[(p1+1):(p1+p2)]
mu1=inveta(x1%*%beta1)
mu2=inveta(x2%*%beta2)

phi=sum((y1-mu1)^2+(y2-mu2)^2-(mu1+mu2))/sum(mu1^2+mu2^2)
alpha=sum((y1-mu1)*(y2-mu2))/(phi*sum(mu1*mu2))

lammda=(1+alpha)/(phi*alpha)
#print(phi)
#print(alpha)
#print(lammda)
}
#print(y1)
#print(mu1)
#print(y2)
#print(mu2)

#cormu=cor(mu1,mu2)
#cory=cor(y1,y2)
#print(cormu)
#print(cory)

dy1=y1-mu1
dy2=y2-mu2

#meany1_mean(y1)
#meany2_mean(y2)
meand1=mean(dy1)
meand2=mean(dy2)
stdd1=sd(dy1)
stdd2=sd(dy2)
meanmu1=mean(mu1)
meanmu2=mean(mu2)

mse1=sum(dy1^2)/(n-1)
mse2=sum(dy2^2)/(n-1)

#print(meany1)
#print(meany2)
#print(meand1)
#print(meand2)
#print(stdd1)
#print(stdd2)


asymcov=solve(FI)
list(beta1,beta2,phi,alpha,lammda,asymcov,meand1,meand2,mse1,mse2,meanmu1,meanmu2)
#list(beta1,beta2,phi,alpha,lammda,mu1,mu2,asymcov,meand1,meand2,mse1,mse2,meanmu1,meanmu2)
}

eta=function(mu){
log(mu)
}

inveta=function(eta){
exp(eta)
}

detadmu=function(mu){
diag(c(1/mu[1],1/mu[2]))
}

sigma=function(mu,phi,alpha){
matrix(c(mu[1]+phi*mu[1]^2,alpha*phi*mu[1]*mu[2],alpha*phi*mu[1]*mu[2],mu[2]+phi*mu[2]^2),2,2)
}

# ---------------------------------------------------------------------------------------
# zero altered negative binomial type I (with probability y=0 is nu) 01/03/10
# ---------------------------------------------------------------------------------------
ZANBI = function (mu.link = "log", sigma.link = "log", nu.link = "logit") 
{
    mstats <- checklink("mu.link", "ZANBI", substitute(mu.link), 
        c("inverse", "log", "identity"))
    dstats <- checklink("sigma.link", "ZANBI", substitute(sigma.link), 
        c("inverse", "log", "identity"))
    vstats <- checklink("nu.link", "ZANBI", substitute(nu.link), 
        c("logit", "probit", "cloglog", "log", "own"))

    structure(list(family = c("ZANBI", "Zero altered negative binomial type I"),
               parameters = list(mu = TRUE, sigma = TRUE, nu = TRUE),
                    nopar = 3,
                     type = "Discrete",
                  mu.link = as.character(substitute(mu.link)),
               sigma.link = as.character(substitute(sigma.link)), 
                  nu.link = as.character(substitute(nu.link)),
               mu.linkfun = mstats$linkfun, 
            sigma.linkfun = dstats$linkfun,
               nu.linkfun = vstats$linkfun, 
               mu.linkinv = mstats$linkinv,
            sigma.linkinv = dstats$linkinv, 
               nu.linkinv = vstats$linkinv,
                    mu.dr = mstats$mu.eta,
                 sigma.dr = dstats$mu.eta, 
                    nu.dr = vstats$mu.eta,
                  dldm = function(y,mu,sigma,nu) {dldm0 <- NBI()$dldm(y,mu,sigma) + dNBI(0,mu,sigma)*NBI()$dldm(0,mu,sigma)/(1-dNBI(0,mu,sigma))
                         dldm <- ifelse(y==0, 0 , dldm0)
                         dldm}, 
               d2ldm2 = function(y,mu,sigma,nu) {dldm0 <- NBI()$dldm(y,mu,sigma) + dNBI(0,mu,sigma)*NBI()$dldm(0,mu,sigma)/(1-dNBI(0,mu,sigma))
                         dldm <- ifelse(y==0, 0 , dldm0)
                        d2ldm2 <- -dldm*dldm
                         d2ldm2 <- ifelse(d2ldm2 < -1e-15, d2ldm2,-1e-15)    
                        d2ldm2},
                 dldd = function(y,mu,sigma,nu) {dldd0 <- NBI()$dldd(y,mu,sigma) + dNBI(0,mu,sigma)*NBI()$dldd(0,mu,sigma)/(1-dNBI(0,mu,sigma))
                         dldd <- ifelse(y==0, 0 , dldd0)
                         dldd}, 
               d2ldd2 = function(y,mu,sigma,nu) {dldd0 <- NBI()$dldd(y,mu,sigma) + dNBI(0,mu,sigma)*NBI()$dldd(0,mu,sigma)/(1-dNBI(0,mu,sigma))
                         dldd <- ifelse(y==0, 0 , dldd0)
                  d2ldd2 <- -dldd^2  
                  d2ldd2 <- ifelse(d2ldd2 < -1e-15, d2ldd2,-1e-15)  
                  d2ldd2}, 
                 dldv = function(y,mu,sigma,nu) {dldv <- ifelse(y==0, 1/nu, -1/(1-nu))
                         dldv}, 
               d2ldv2 = function(y,mu,sigma,nu) {d2ldv2 <- -1/(nu*(1-nu))
              d2ldv2 <- ifelse(d2ldv2 < -1e-15, d2ldv2,-1e-15)  
              d2ldv2},
        d2ldmdd = function(y) {dldm0 <- NBI()$dldm(y,mu,sigma) + dNBI(0,mu,sigma)*NBI()$dldm(0,mu,sigma)/(1-dNBI(0,mu,sigma))
                         dldm <- ifelse(y==0, 0 , dldm0)
                         dldd0 <- NBI()$dldd(y,mu,sigma) + dNBI(0,mu,sigma)*NBI()$dldd(0,mu,sigma)/(1-dNBI(0,mu,sigma))
                         dldd <- ifelse(y==0, 0 , dldd0)
                         d2ldm2<--dldm*dldd
                         d2ldm2}, 
                 d2ldmdv = function(y) {d2ldmdv=0  
            d2ldmdv},
        d2ldddv = function(y) {d2ldddv=0
            d2ldddv},        
        G.dev.incr  = function(y,mu,sigma,...) -2*dZANBI(y, mu = mu, sigma = sigma, nu=nu, log = TRUE), 
        rqres = expression(
                          rqres(pfun="pZANBI", type="Discrete", ymin=0, y=y, mu=mu, sigma=sigma)
                                 ), 
           mu.initial = expression(mu <- (y + mean(y))/2),            
##           mu.initial = expression(mu <-  y+0.5),
         sigma.initial = expression(
         sigma <- rep( max( ((var(y)-mean(y))/(mean(y)^2)),0.1),length(y))),
           nu.initial = expression(nu <- rep(0.3, length(y))),
              mu.valid = function(mu) all(mu > 0) , 
           sigma.valid = function(sigma)  all(sigma > 0), 
             nu.valid = function(nu) all(nu > 0 & nu < 1),           
               y.valid = function(y)  all(y >= 0)
          ),
            class = c("gamlss.family","family"))
}
#-------------------------------------------------------------------------------------------
dZANBI<-function(x, mu = 1, sigma = 1, nu = 0.3, log = FALSE)
 { 
        if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
        if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", "")) 
        if (any(nu <= 0)|any(nu >= 1))  stop(paste("nu must be between 0 and 1 ", "\n", ""))
        if (any(x < 0) )  stop(paste("x must be >=0", "\n", ""))  
        if (length(sigma)>1) fy <- ifelse(sigma>0.0001, dnbinom(x, size=1/sigma, mu = mu, log = T), 
                                          dPO(x, mu = mu, log = T) )
        else fy <- if (sigma<0.0001) dPO(x, mu = mu, log = T) 
                   else dnbinom(x, size=1/sigma, mu = mu, log = T)
         if (length(sigma)>1) fy0 <- ifelse(sigma>0.0001, dnbinom(0, size=1/sigma, mu = mu, log = T), 
                                          dPO(0, mu = mu, log = T) )
        else fy0 <- if (sigma<0.0001) dPO(0, mu = mu, log = T) 
                   else dnbinom(0, size=1/sigma, mu = mu, log = T)
                  
          logfy <- rep(0, length(x))
          logfy <- ifelse((x==0), log(nu), log(1-nu) + fy - log(1-exp(fy0)))          

          if(log == FALSE) fy2 <- exp(logfy) else fy2 <- logfy
          fy2
  }
#------------------------------------------------------------------------------------------
pZANBI <- function(q, mu = 1, sigma = 1, nu = 0.3, lower.tail = TRUE, log.p = FALSE)
  {     
        if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
        if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", "")) 
        if (any(nu <= 0)|any(nu >= 1))  #In this parametrization  nu = alpha
                    stop(paste("nu must be between 0 and 1 ", "\n", ""))
        if (any(q < 0) )  stop(paste("y must be >=0", "\n", ""))
        if (length(sigma)>1) cdf1 <- ifelse(sigma>0.0001, pnbinom(q, size=1/sigma, mu=mu), 
                                          ppois(q, lambda = mu) )
        else cdf1 <- if (sigma<0.0001) ppois(q, lambda = mu)
                   else pnbinom(q, size=1/sigma, mu=mu)
 
        if (length(sigma)>1) cdf0 <- ifelse(sigma>0.0001, pnbinom(0, size=1/sigma, mu=mu), 
                                          ppois(0, lambda = mu) )
        else cdf0 <- if (sigma<0.0001) ppois(0, lambda = mu)
                   else pnbinom(0, size=1/sigma, mu=mu)
#         cdf <- rep(0,length(q))
#         cdf1 <- ppois(q, lambda = mu, lower.tail = TRUE, log.p = FALSE)
#         cdf2 <- ppois(0, lambda = mu, lower.tail = TRUE, log.p = FALSE)
         cdf3 <- nu+((1-nu)*(cdf1-cdf0)/(1-cdf0))
         cdf <- ifelse((q==0),nu,  cdf3)
         if(lower.tail == TRUE) cdf <- cdf else cdf <-1-cdf
         if(log.p==FALSE) cdf <- cdf else cdf <- log(cdf)    
         cdf
   }
#------------------------------------------------------------------------------------------
qZANBI <- function(p, mu = 1, sigma = 1, nu = 0.3, lower.tail = TRUE, log.p = FALSE)
  {      
          if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
          if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", ""))
          if (any(nu <= 0)|any(nu >= 1))  #In this parametrization  nu = alpha
                     stop(paste("nu must be between 0 and 1 ", "\n", ""))
          if (any(p < 0) | any(p > 1))  stop(paste("p must be between 0 and 1", "\n", ""))    
          if (log.p == TRUE) p <- exp(p)   else p <- p
          if (lower.tail == TRUE)  p <- p  else p <- 1 - p
          pnew <- (p-nu)/(1-nu)
        if (length(sigma)>1) cdf0 <- ifelse(sigma>0.0001, pnbinom(0, size=1/sigma, mu=mu), 
                                          ppois(0, lambda = mu) )
        else cdf0 <- if (sigma<0.0001) ppois(0, lambda = mu)
                   else pnbinom(0, size=1/sigma, mu=mu)
          pnew2 <- cdf0*(1-pnew) + pnew           
          pnew2 <- ifelse((pnew2 > 0 ),pnew2, 0)
          if (length(sigma)>1) q <- ifelse(sigma>0.0001,  qnbinom(pnew2, size=1/sigma, mu=mu), 
                                          qpois(pnew2, lambda = mu) )
          else q <- if (sigma<0.0001) qpois(pnew2, lambda = mu)
                   else qnbinom(pnew2, size=1/sigma, mu=mu)
           # q2 <- suppressWarnings(ifelse((pnew > 0 ), q, 0))
#          suppressWarnings(q <- ifelse((pnew > 0 ), qpois(pnew, lambda = mu, ), 0))
          q
   }
#------------------------------------------------------------------------------------------
rZANBI <- function(n, mu = 1, sigma = 1, nu = 0.3)
  { 
          if (any(mu <= 0) )  stop(paste("mu must be greater than 0 ", "\n", "")) 
          if (any(sigma <= 0) )  stop(paste("sigma must be greater than 0 ", "\n", "")) 
          if (any(nu <= 0)|any(nu >= 1))  #In this parametrization  nu = alpha
          stop(paste("nu must be between 0 and 1 ", "\n", ""))
          if (any(n <= 0))  stop(paste("n must be a positive integer", "\n", ""))  
          n <- ceiling(n)
          p <- runif(n)
          r <- qZANBI(p, mu=mu, sigma=sigma, nu=nu)
          r
  }
#------------------------------------------------------------------------------------------

# syn.nb2nb2fm.r   Synthetic NB2-NB2 Finite Mixture model
# Table 13.3: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
library(gamlss.mx)
nobs <- 50000
x1 <- (runif(nobs))      
x2 <- qnorm(runif(nobs))      
xb1 <- 1 + .25*x1 - .75*x2
xb2 <- 2 + .75*x1 - 1.25*x2     
a1 <- .5                        
a2 <- 1.5
ia1 <- 1/a1
ia2 <- 1/a2                     
exb1 <- exp(xb1) 
exb2 <- exp(xb2)                 
xg1 <- rgamma(n = nobs, shape = a1, rate = a1)  
xg2 <- rgamma(n = nobs, shape = a2, rate = a2)  
xbg1 <-exb1*xg1 
xbg2 <-exb2*xg2                  
nby1 <- rpois(nobs, xbg1)
nby2 <- rpois(nnobs, xbg2)       
nbxnb <- nby2
nbxnb <- ifelse(runif(nobs) > .9, nby1, nbxnb)
nxn <- gamlssNP(nbxnb~x1+x2, random=~1,family=NBI, K=2)
summary(nxn)

# hilbe.NBR2.F8.12.r
# Negative binomial regression distributions with 
#    user specified series of alpha values for a specified mean value
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figures 8.12   default: alpha at .009, .1, .3, .5 and mean=10
#
obs <- 11
alpha <- c(.009, .1, .3, .5)
y <- 0:30
mu <- 10
amu <- mu*alpha
layout(1) 
for (i in 1:length(amu)) { 
ynb2 = exp(
        y*log(amu[i]/(1+amu[i])) 
     - (1/alpha[i])*log(1+amu[i]) 
     + log( gamma(y +1/alpha[i]) )
     - log( gamma(y+1) ) 
     - log( gamma(1/alpha[i]) ) 
)
if (i==1) { 
plot(y, ynb2, col=i, type='l', lty=i) 
  } else { 
  lines(y, ynb2, col=i, lty=i) 
  } 
}

ml.nbc <- function(formula, data, start = NULL, verbose = FALSE) {
  mf <- model.frame(formula, data)
  mt <- attr(mf, "terms")
  y <- model.response(mf, "numeric")
  nbcX <- model.matrix(formula, data = data)
  nbc.reg.ml <- function(b.hat, X, y) {
    a.hat <- b.hat[1]
    xb.hat <- X %*% b.hat[-1]
    mu.hat <- 1 / ((exp(-xb.hat)-1)*a.hat)
    p.hat <- 1 / (1 + a.hat*mu.hat)
    r.hat <- 1 / a.hat
    sum(dnbinom(y,
                size = r.hat,
                prob = p.hat,
                log = TRUE))
    }
  if (is.null(start))
    start <- c(0.5, -1, rep(0, ncol(nbcX) - 1))
  fit <- optim(start,           
               nbc.reg.ml,
               X = nbcX,
               y = y,
               control = list(
                 fnscale = -1,
                 maxit = 10000),
               hessian = TRUE
               )
  if (verbose | fit$convergence > 0) print(fit)
  beta.hat <- fit$par
  se.beta.hat <- sqrt(diag(solve(-fit$hessian)))
  results <- data.frame(Estimate = beta.hat,
                        SE = se.beta.hat,
                        Z = beta.hat / se.beta.hat,
                        LCL = beta.hat - 1.96 * se.beta.hat,
                        UCL = beta.hat + 1.96 * se.beta.hat)
  rownames(results) <- c("alpha", colnames(nbcX))
  results <- results[c(2:nrow(results), 1),]
  return(results)
}

# NB2 maximum likelihood function  J Hilbe 11Apr 2010
ml.nb2 <- function(formula, data, start = NULL, verbose = FALSE) {
  mf <- model.frame(formula, data)
  mt <- attr(mf, "terms")
  y <- model.response(mf, "numeric")
  nb2X <- model.matrix(formula, data = data)
  nb2.reg.ml <- function(b.hat, X, y) {
    a.hat <- b.hat[1]
    xb.hat <- X %*% b.hat[-1]
    mu.hat <- exp(xb.hat)
    r.hat <-  1 / a.hat    
    sum(dnbinom(y,
                size = r.hat,
                mu = mu.hat,
                log = TRUE))
    }
  if (is.null(start))
    start <- c(0.5, -1, rep(0, ncol(nb2X) - 1))
  fit <- optim(start,           
               nb2.reg.ml,
               X = nb2X,
               y = y,
               control = list(
                 fnscale = -1,
                 maxit = 10000),
               hessian = TRUE
               )
  if (verbose | fit$convergence > 0) print(fit)
  beta.hat <- fit$par
  se.beta.hat <- sqrt(diag(solve(-fit$hessian)))
  results <- data.frame(Estimate = beta.hat,
                        SE = se.beta.hat,
                        Z = beta.hat / se.beta.hat,
                        LCL = beta.hat - 1.96 * se.beta.hat,
                        UCL = beta.hat + 1.96 * se.beta.hat)
  rownames(results) <- c("alpha", colnames(nb2X))
  results <- results[c(2:nrow(results), 1),]
  return(results)
}

load("c://source/medpar.RData")
medpar$type <- factor(medpar$type)
med.nb2 <- ml.nb2(los ~ hmo + white + type, data = medpar)
med.nb2

# syn.poisson.r  
# Table 6.4 : Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
nobs <- 50000
x1 <- qnorm(runif(nobs))
x2 <- qnorm(runif(nobs))
py <-rpois(nobs, exp(2 + .75*x1 -1.25*x2))
jhpoi <-glm(py ~ x1 + x2, family=poisson)
summary(jhpoi)
confint(jhpoi)

# hilbe.NBR2.F8.10.r
# Negative binomial regression distributions with 
#    user specified series of alpha values for a specified mean value
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figures 8.10   default: alpha at 0, .33, .67, 1, 1.5, 3 and mean=5
#
obs <- 11
alpha <- c(.009, .33, .67, 1, 1.5, 3)
y <- 0:10
mu <- 5
amu <- mu*alpha
layout(1) 
for (i in 1:length(amu)) { 
ynb2 = exp(
        y*log(amu[i]/(1+amu[i])) 
     - (1/alpha[i])*log(1+amu[i]) 
     + log( gamma(y +1/alpha[i]) )
     - log( gamma(y+1) ) 
     - log( gamma(1/alpha[i]) ) 
)
if (i==1) { 
plot(y, ynb2, col=i, type='l', lty=i) 
  } else { 
  lines(y, ynb2, col=i, lty=i) 
  } 
}

# hilbe.NBR2.F9.1alt.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figure 9.1  Table Creation - no graphic  Alternative
# 
rm(list=ls())
load("c://source/affairs.RData") 
affmodel <- glm(naffairs~ kids + avgmarr + hapavg +  vryhap + notrel + slghtrel + smerel + vryrel + yrsmarr3 + yrsmarr4 + yrsmarr5 + yrsmarr6, family=poisson, data=affairs)
mu <- fitted.values(affmodel) 
avgp <- sapply(0:13, function(i) mean(exp(-mu)*(mu^i)/factorial(i)))
propObsv <- with(subset(affairs, naffairs < 14), table(naffairs) / nrow(affairs))
Diff <- c(0,propObsv)*100 - avgp[1:25]*100
data.frame(LOS=0:13, ObsProp=c(0,propObsv)*100, avgp*100, Diff)

# hilbe.NBR2.F6.1.r
# Table 6.4 plus added code
# Synthetic Poisson model with a user defined values; 
#   graphic of predicted mean values
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Table 6.4; Figure 6.1
#
nobs <- 50000
x1 <- qnorm(runif(nobs))
x2 <- qnorm(runif(nobs))
py <-rpois(nobs, exp(2 + .75*x1 -1.25*x2))
mpy <- mean(py)    
ypoi <- (exp(-mpy)*mpy^py)/gamma(py+1)
 plot(ypoi~ py, xlim=c(0,50), main="Synthetic Poisson Model: Mean=21")

# hilbe.obspred.r
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Table 6.15 LOS : observed vs predicted and difference days 0-25
# ammend as needed for own data
#
library(MASS)
rm(list=ls())
load("c://source/medpar.RData")
mdpar <- glm(los ~ hmo+white+type2+type3, family=poisson, data=medpar)
mu <- fitted(mdpar)
avgp <- sapply(0:25, function(i) mean(exp(-mu)*(mu^i)/factorial(i)))
propObsv <- with(subset(medpar, los < 26), table(los) / nrow(medpar))
Diff <- c(0,propObsv)*100 - avgp[1:25]*100
data.frame(LOS=0:25, ObsProp=c(0,propObsv)*100, avgp*100, Diff)

# ==== GRAPH OF OBSERVED VS PREDICTED LOS =======================
plot(0:25, avgp, type="b", xlim=c(0,25),
main = "Observed vs Predicted Days",
xlab = "Days in Hospital", ylab = "Probability of LOS")
lines(0:25, c(0,propObsv), type = "b", pch = 2)
legend("topright", legend = c("Predicted Days","Observed Days"),
           lty = c(1,1), pch = c(1,2))

# syn.cgeo.r     Synthetic canonical geometric regression
# Table 10.3: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
library(MASS)
nobs <- 50000
x2 <- runif(nobs)
x1 <- runif(nobs)
xb <- 1.25*x1 + .1*x2 - 1.5   
mu <- 1/(exp(-xb)-1)
p <- 1/(1+mu)
r <- 1
gcy <- rnbinom(nobs, size=r, prob = p)
source("c://source/ml.nbc.r")  # NB-C function
g2y <- ml.nbc(y ~ x1 + x2)
summary(g2y)
library(gamlss)
hnbii <- gamlss(y~ x1 + x2, family=NBII)
summary(hnbii) 

# syn.bin_logit.r     Synthetic grouped logistic regression
# Table 9.22: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
nobs <- 50000                                  
x1 <- runif(nobs)                      
x2 <- runif(nobs)                      
d <- rep(1:5, each=10000, times=1)*100 # denominator
xb <- 2 + .75*x1 - 1.25*x2             # linear predictor; values
exb <- 1/(1+exp(-xb))                                       # fit; predicted prob
by  <- rbinom(nobs, size = d, p = exb) # random binomial variate
dby <- d - by                          # denominator - numerator
gby <- glm(cbind(by,dby) ~ x1 + x2, family=binomial(link="logit"))
summary(gby)                           # displays model output

# geo_rng.r     
# Table 10.2: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
# Synthetic geometric regression
#
library(MASS)
nobs <- 50000
x1 <- runif(nobs)
x2 <- runif(nobs)
xb <- 2 + .75*x1 - 1.25*x2   # parameter values
exb <- exp(xb)               # Poisson predicted value
xg <- rgamma(n = nobs, shape = 1, rate = 1)  # gamma variate, param 1,1
xbg <-exb*xg                 # mix Poisson and gamma variates
gy <- rpois(nobs, xbg)       # generate NB2 variates
geo <-glm.nb(gy ~ x1 + x2)   # model geometric
summary(geo)
nbg <- glm(gy ~ x1 + x2,, family=negative.binomial(1))
summary(nbg)                 # GLM NB2 with ?=1    

# Modeling Count Data, Cambridge University Press (2014)
# Joseph M Hilbe  hilbe@asu.edu

# ===============================================================
#           CHAPTER 1  Varieties of Count Data
# ===============================================================
#
# 1.2.1
# ------
#
# R CODE
sbp    <- c(131,132,122,119,123,115)
male   <- c(1,1,1,0,0,0)
smoker <- c(1,1,0,0,1,0)
age    <- c(34,36,30,32,26,23)
summary(reg1 <- lm(sbp~ male+smoker+age))
mu <- predict(reg1)
mu
cof <- reg1$coef
cof
xb <- cof[1] + cof[2]*male + cof[3]*smoker + cof[4]*age
xb
diff <- sbp - mu
diff

# 1.2.3
# --------

# Table 1.2a R: Code for Figure 1.2a
# =====================================================
obs <- 15; mu <- 4; y <- (0:140)/10; alpha <- .5
amu <- mu*alpha; layout(1)
all.lines <- vector(mode = 'list', length = 5)
for (i in 1:length(mu)) {
    yp = exp(-mu[i])*(mu[i]^y)/factorial(y)
    ynb1 = exp(  log(gamma(mu[i]/alpha + y))
               - log(gamma(y+1)) 
               - log(gamma(mu[i]/alpha)) 
               + (mu[i]/alpha)*log(1/(1+alpha)) 
               + y*log(1-1/(1+alpha)))
    ynb2 = exp(  y*log(amu[i]/(1+amu[i])) 
               - (1/alpha)*log(1+amu[i]) 
               + log( gamma(y +1/alpha) )
               - log( gamma(y+1) ) 
               - log( gamma(1/alpha) ))
    ypig = exp( (-(y-mu[i])^2)/(alpha*2*y*mu[i]^2)) * (sqrt(1/(alpha*2*pi*y^3)))
    ygp = exp( log((1-alpha)*mu[i]) 
               + (y-1)*log((1-alpha) * mu[i]+alpha*y)
               - (1-alpha)*mu[i] 
               - alpha*y 
               - log(gamma(y+1)))
    all.lines = list(yp = yp, ynb1 = ynb1, ynb2 = ynb2, ypig = ypig, ygp = ygp)
    ymax = max(unlist(all.lines), na.rm=TRUE)
    cols = c("red","blue","black","green","purple")
    plot(y, all.lines[[1]], ylim = 
         c(0, ymax), type = "n", main="5 Count Distributions: mean=4; alpha=0.5")
    for (j in 1:5)
        lines(y, all.lines[[j]], ylim = c(0, ymax), col=cols[j],type='b',pch=19, lty=j) 
         legend("topright",cex = 1.5, pch=19,
         legend=c("NB2","POI","PIG","NB1","GP"),
         col = c(1,2,3,4,5),
         lty = c(1,1,1,1,1),
         lwd = c(1,1,1,1,3))
}
# =======================================================

# 1.4.2
# -------

# Table 1.4 R: Poisson probabilities for y from 0 through 4
# ===========================================================
y <- c(4, 2, 0,3, 1, 2)
y0 <- exp(-2)* (2^0)/factorial(0)
y1 <- exp(-2)* (2^1)/factorial(1)
y2 <- exp(-2)* (2^2)/factorial(2)
y3 <- exp(-2)* (2^3)/factorial(3)
y4 <- exp(-2)* (2^4)/factorial(4)
poisProb <- c(y0, y1, y2, y3, y4); poisProb

# OR
dpois(0:4, lambda=2)

# CUMULATIVE
ppois(0:4, lambda=2)

# to plot a histogram
py <- 0:4
plot(poisProb ~ py, xlim=c(0,4), type="o", main="Poisson Prob 0-4: Mean=2")
# ============================================================


# Table 1.5 R : Code for Figure 1.3
# ===============================
m<- c(0.5,1,3,5)           #Poisson means 
y<- 0:11                   #Observed counts 
layout(1) 
for (i in 1:length(m)) { 
  p<- dpois(y, m[i])       #poisson pdf 
  if (i==1) { 
  plot(y, p, col=i, type='l', lty=i) 
  } else { 
  lines(y, p, col=i, lty=i) 
  } 
}
# ===============================


# ===============================================================
#              CHAPTER 2  Poisson Regression
# ===============================================================
#
# 2.3
# ----
#
# Table 2.4  R:  Synthetic Poisson Model
# =============================================
library(MASS); library(COUNT); set.seed(4590); nobs <- 50000
x1 <- runif(nobs); x2 <- runif(nobs); x3 <- runif(nobs)
py <- rpois(nobs, exp(1 + 0.75*x1 - 1.25*x2 + .5*x3))
cnt <- table(py)
dataf <- data.frame(prop.table(table(py) ) )
dataf$cumulative <- cumsum(dataf$Freq)
datafall <- data.frame(cnt, dataf$Freq*100, dataf$cumulative * 100)
datafall; summary(py)
summary(py1 <- glm(py ~ x1 + x2 + x3, family=poisson))
confint.default(py1); py1$aic/(py1$df.null+1)
r <- resid(py1, type = "pearson")
pchi2 <- sum(residuals(py1, type="pearson")^2)
disp <- pchi2/py1$df.residual; pchi2; disp
# =====================================================



# Table 2.6 R: Monte Carlo Poisson
# ==================================================
 mysim <- function()
 {
  nobs <- 50000
  x1 <- runif(nobs)
  x2 <- runif(nobs)
  x3 <- runif(nobs)
  py <- rpois(nobs, exp(2 + .75*x1 - 1.25*x2 + .5*x3))       
  poi <- glm(py ~ x1 + x2 + x3, family=poisson)  
    pr <- sum(residuals(poi, type="pearson")^2)
    prdisp <- pr/poi$df.residual
    beta <- poi$coef
    list(beta,prdisp)
}
B <- replicate(100, mysim())   
apply(matrix(unlist(B[1,]),4,100),1,mean)

# ===================================================
# Dispersion
mean(unlist(B[2,]))

# 2.4
# -----
# Table 2.7 R:  Example Poisson Model and Associated Statistics
# ===========================================================
library(COUNT)
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
cage <- rwm1984$age - mean(rwm1984$age)
summary(poic <- glm(docvis ~ outwork + cage, family=poisson, data=rwm1984))
pr <- sum(residuals(poic, type="pearson")^2)  # Pearson Chi2
pr/poic$df.residual                           # dispersion statistic
modelfit(poic)
cnt <- table(rwm1984$docvis)
dataf <- data.frame(prop.table(table(rwm1984$docvis) ) )
dataf$cumulative <- cumsum(dataf$Freq)
datafall <- data.frame(cnt, dataf$Freq*100, dataf$cumulative * 100)
datafall
# ===========================================================

# Table 2.8 R: Change Levels in Categorical Predictor
# ======================================================
levels(rwm1984$edlevel)              # levels of edlevel
elevel <- rwm1984$edlevel            # new variable
levels(elevel)[2] <- "Not HS grad"   # assign level 1 to 2
levels(elevel)[1] <- "HS"            # rename level 1 to "HS"
levels(elevel)                       # levels of elevel
summary(tst2 <- glm(docvis ~ outwork + cage + female + married + kids 
    + factor(elevel), family=poisson, data=rwm1984))
# =======================================================


# 2.5.1
# -------

summary(pyq <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))

# Likelihood Profiling of SE
confint(pyq)

# Traditional Model-based SE
confint.default(pyq)


# 2.5.2
# ------

# Table 2.11  R: Poisson Model  - Rate Ratio Parameterization
# ============================================================
library(COUNT)
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
summary(poi1 <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))
pr <- sum(residuals(poi1, type="pearson")^2)  # Pearson Chi2
pr/poi1$df.residual                    # dispersion statistic
poi1$aic / (poi1$df.null+1)            # AIC/n
exp(coef(poi1))                        # IRR
exp(coef(poi1))*sqrt(diag(vcov(poi1))) # delta method 
exp(confint.default(poi1))             # CI of IRR
# ============================================================


# 2.6
# ----

# Table 2.12 R:  Poisson with Exposure
# ===========================================
data(fasttrakg)
summary(fast <- glm(die ~ anterior + hcabg + factor(killip), 
                        family=poisson, 
                        offset=log(cases), 
                        data=fasttrakg))
exp(coef(fast))
exp(coef(fast))*sqrt(diag(vcov(fast))) 
exp(confint.default(fast))             
modelfit(fast)
# ============================================


# 2.7
# ----

# R  prediction
myglm <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984)
lpred <- predict(myglm, newdata=rwm1984, type="link", se.fit=TRUE)
up <- lpred$fit + 1.96*lpred$se.fit; lo <- lpred$fit - 1.96*lpred$se.fit
eta <- lpred$fit ; mu <- myglm$family$linkinv(eta)
upci <- get(myglm$family$link)(up); loci <- get(myglm$family$link)(lo)


# 2.8.1
# -----

# Table 2.14 R:  Marginal Effects at Mean
# ===========================================================
library(COUNT)
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
summary(pmem <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))
mout <- mean(rwm1984$outwork); mage <- mean(rwm1984$age)
xb <- coef(pmem)[1] + coef(pmem)[2]*mout + coef(pmem)[3]*mage
dfdxb <- exp(xb) * coef(pmem)[3]
mean(dfdxb)
# ===========================================================


# 2.8.2
# -------

# R CODE
mean(rwm1984$docvis) * coef(pmem)[3]

# 2.8.3
# -------

# R CODE  discrete change
summary(pmem <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))
mu0 <- exp(pmem$coef[1] + pmem$coef[3]*mage)
mu1 <- exp(pmem$coef[1] + pmem$coef[2] + pmem$coef[3]*mage)
pe <- mu1 - mu0
mean(pe)

# R CODE  avg partial effects
summary(pmem <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))
bout = coef(pmem)[2]
mu = fitted.values(pmem)
xb = pmem$linear.predictors
pe_out = 0
pe_out = ifelse(rwm1984$outwork == 0, exp(xb + bout)-exp(xb), NA)
pe_out = ifelse(rwm1984$outwork == 1, exp(xb)-exp(xb-bout),pe_out)
mean(pe_out) 


# ===============================================================
#              CHAPTER 3 Testing Overdispersion
# ===============================================================
#
# 3.1
# ----


# Table 3.1  R: Deviance Goodness-of-Fit Test
# ================================================================
library(COUNT); data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
mymod <-glm(docvis ~ outwork + age, family=poisson, data=rwm1984)
mymod

dev<-deviance(mymod); df<-df.residual(mymod)
p_value<-1-pchisq(dev,df)
print(matrix(c("Deviance GOF","D","df","p-value", " ", 
   round(dev,4),df, p_value), ncol=2))

# ==================================================================



# R CODE
mymod <-glm(docvis ~ outwork + age, family=poisson, data=rwm1984)
pr <- sum(residuals(mymod, type="pearson")^2)   # get Pearson Chi2
pchisq(pr, mymod$df.residual, lower=F)          # calc p-value 
pchisq(mymod$deviance, mymod$df.residual, lower= F)  # calc p-vl

# P__disp is now available when the COUNT pacakge is loaded. 
# Table 3.2  R: Function to Calculate Pearson Chi2 and Dispersion Statistics
# =============================================================
P__disp <- function(x) {
   pr <- sum(residuals(x, type="pearson")^2)
   dispersion <- pr/x$df.residual
   cat("\n Pearson Chi2 = ", pr , 
       "\n Dispersion   = ", dispersion, "\n")
}
# =============================================================

P__disp(mymod)

# R CODE
library(COUNT)
data(rwm5yr)
rwm1984 <- subset(rwm5yr, year==1984)
mymod <-glm(docvis ~ outwork + age, family=poisson, data=rwm1984)
P__disp(mymod)

# 3.3.1
# ----

# Table 3.4 R:  Z-Score Test
# ===========================================================
library(COUNT); data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
summary(poi <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))
mu <-predict(poi, type="response")
z <- ((rwm1984$docvis - mu)^2 - rwm1984$docvis)/ (mu * sqrt(2))
summary(zscore <- lm(z ~ 1))
# ==========================================================


# 3.3.2
# -----
# Table 3.5 R: Lagrange Multiplier Test
# ===============================================
obs <- nrow(rwm1984)   # continue from Table 3.2
mmu <- mean(mu); nybar <- obs*mmu; musq <- mu*mu
mu2 <- mean(musq)*obs
chival <- (mu2 - nybar)^2/(2*mu2); chival 
pchisq(chival,1,lower.tail = FALSE)
# ===============================================

# 3.3.3
# -----

# Table 3.7  R:  Poisson Model with Ancillary Statistics
# ============================================================
library(COUNT); data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
summary(poi1 <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))
pr <- sum(residuals(poi1, type="pearson")^2)  # Pearson Chi2
pr/poi1$df.residual                     # dispersion statistic
poi1$aic / (poi1$df.null+1)             # AIC/n
exp(coef(poi1))                         # IRR
exp(coef(poi1))*sqrt(diag(vcov(poi1)))  # delta method 
exp(confint.default(poi1))              # CI of IRR
modelfit(poi1)                          # same as Stata abic
sd(rwm1984$docvis)^2                    # observed variance
xbp <- predict(poi1)                    # xb, linear predictor
mup <- exp(xbp)                         # mu, fitted Poisson 
mean(mup)                               # expected variance: mean=variance
# Table of observed vs expected counts
rbind(obs=table(rwm1984$docvis)[1:18], 
     exp = round(sapply(0:17, function(x)sum(dpois(x, fitted(poi1))))))
meany <- mean(rwm1984$docvis)           # mean docvis
expect0 <- exp(-meany)*meany^0 / exp(log(factorial(0))) # expected prob of 0
zerodays <- (poi1$df.null+1) *expect0   # expected zero days
obs=table(rwm1984$docvis)[1:18]         # observed number values in each count 0-17
exp = round(sapply(0:17, function(x)sum(dpois(x, fitted(poi1))))) # expected each count
chisq.test(obs, exp)                    # ChiSq test if obs & exp from same pop
# ============================================================


# 3.4.1
# -----

data(medpar)

# R:  quasipoisson
# =============================================================
summary(poiql <- glm(los ~ hmo + white + hmo + factor(type), 
                           family=quasipoisson, data=medpar))
# =============================================================


# Table 3.8  R:  Scaling SE  Medpar Data
# =====================================================
library(COUNT); data(medpar); attach(medpar)
summary(poi <- glm(los ~ hmo + white + factor(type), family=poisson, 
    data=medpar)) 
confint(poi)                                    # profile confidence interval
pr <- sum(residuals(poi,type="pearson")^2)      # Pearson statistic
dispersion <- pr/poi$df.residual; dispersion          # dispersion
sse <- sqrt(diag(vcov(poi))) * sqrt(dispersion); sse  # model SE
# OR
poiQL <- glm(los ~ hmo + white + factor(type), family=quasipoisson, 
   data=medpar)
coef(poiQL); confint(poiQL)                     # coeff & scaled SEs
modelfit(poi)                                   # AIC,BIC statistics
# ======================================================


# 3.4.2
# ------

# Table 3.10  R: Quasi-likelihood Poisson Standard Errors
# ===============================================
poiQL <- glm(los ~ hmo+white+type2+type3, family=poisson, data=medpar)
summary(poiQL)
pr <-sum(residuals(poiQL, type="pearson")^2 ) 
disp <- pr/poiQL$df.residual        # Pearson dispersion
se <-sqrt(diag(vcov(poiQL)))
QLse <- se/sqrt(disp); QLse
# ===============================================


# 3.4.3
# ------

# Table 3.12  R:  Robust Standard Errors of medpar Model
# ====================================================
library(sandwich)
poi <- glm(los ~ hmo + white + factor(type), family=poisson, data=medpar)
vcovHC(poi)
sqrt(diag(vcovHC(poi, type="HC0")))                 # final HC0 = H-C-zero
# Clustering
poi <- glm(los ~ hmo + white + factor(type), family=poisson, data=medpar)
library(haplo.ccs)
sandcov(poi, medpar$provnum)
sqrt(diag(sandcov(poi, medpar$provnum)))
# ====================================================

summary(poi1 <- glm(los ~ hmo+white+factor(type), family=poisson, data=medpar))

# 3.4.4
# ------

# Table 3.13  R: Bootstrap Standard Errors
# ======================================================
library(COUNT); library(boot); data(medpar)
poi <- glm(los ~ hmo + white + factor(type), family=poisson, data=medpar)
summary(poi)
t <- function (x, i) {
xx <- x[i,]
 bsglm <- glm( los ~ hmo + white + factor(type), family=poisson, data=medpar)
 return(sqrt(diag(vcov(bsglm))))
 }
bse <- boot(medpar, t, R=1000)
sqrt(diag(vcov(poi))); apply(bse$t,2, mean)
# =======================================================

# ===============================================================
#              CHAPTER 4  Assessment of Fit
# ===============================================================
#
# 4.1

# R  Pearson Chi2 and statistic and graph
summary(pexp <- glm(docvis ~ outwork + cage, family=poisson, data=rwm1984))
presid <- residuals(pexp, type="pearson")
pchi2 <- sum(residuals(pexp, type="pearson")^2)  # Pearson Chi2
summary(rwm <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984))
P__disp(rwm)
mu <- predict(rwm)
grd <- par(mfrow = c(2,2))
plot(x=mu, y= rwm$docvis, main = "Response residuals")
plot(x=mu, y= presid, main = "Pearson residuals")

# 4.2.1 
# -------
# Table 4.2 R: Likelihood Ratio Test
# ====================================================
library(COUNT); library(lmtest); data(rwm5yr)
rwm1984 <- subset(rwm5yr, year==1984)
poi1 <- glm(docvis ~ outwork + age, family=poisson, data=rwm1984)
poi1a <- glm(docvis ~ outwork, family=poisson, data=rwm1984)
lrtest(poi1, poi1a)
drop1(poi1, test="Chisq")
# ====================================================

# 4.2.2
# ------
# Chi2 test boundary LR 
pchisq(2.705,1, lower.tail=FALSE)/2

# 4.3.2
# ------

# Table 4.4 R:  Version of Stata User Command, abic 
# ======================================================== 
modelfit <- function(x) { 
obs <- x$df.null + 1 
aic <- x$aic 
xvars <- x$df.null - x$df.residual + 1
rdof <- x$df.residual 
aic_n <- aic/obs 
ll <- xvars - aic/2 
bic_r <- x$deviance - (rdof * log(obs)) 
bic_l <- -2*ll + xvars * log(obs) 
bic_qh <- -2*(ll - xvars * log(xvars))/obs 
c(AICn=aic_n, AIC=aic, BICqh=bic_qh, BICl=bic_l) 
} 
# modelfit(x) # substitute fitted model name for x 
# ======================================================== 
library(COUNT) 
data(medpar) 
mymodel <- glm(los ~ hmo + white + factor(type), family=poisson, data=medpar) 
modelfit(mymodel)

# ===============================================================
#              CHAPTER 5  Negative Binomial Regression
# ===============================================================
#
# 5.3.1

# Table 5.4  R: rwm1984 Modeling Example
# ============================================================
# make certain the appropriate packages are loaded
library(COUNT); data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
# USING glm.nb
summary(nbx <- glm.nb(docvis ~ outwork + age + married + female + 
       edlevel2 + edlevel3 + edlevel4, data=rwm1984))
exp(coef(nbx)); exp(coef(nbx))*sqrt(diag(vcov(nbx))) 
exp(confint.default(nbx))
alpha <- 1/nbx$theta; alpha; P__disp(nbx)
modelfit(nbx) 
xbnb <- predict(poi1); munb <- exp(xbnb)
# expected variance of NB model (using alpha where alpha=1/theta)
mean(munb)+ (1/nbx$theta)*mean(munb)^2
round(sqrt(rbind(diag(vcov(nbx)), diag(sandwich(nbx)))), digits=4)
# USING nbinomial
nb1 <- nbinomial(docvis ~ outwork + age + married + female + 
       edlevel2 + edlevel3 + edlevel4, data=rwm1984)
summary(nb1)
modelfit(nb1)
# ============================================================

# Table 5.5 R: rwm1984 Poisson and NB2 Models
# ============================================================
library(COUNT);library(msme)
data(rwm5yr);rwm1984 <- subset(rwm5yr, year==1984)
# POISSON
poi <- glm(docvis ~ outwork + age + married + female + 
                    edlevel2 + edlevel3 + edlevel4, 
                    family = poisson, data = rwm1984)
summary(poi)
#NB2
nb1 <- nbinomial(docvis ~ outwork + age + married + female + 
        edlevel2 + edlevel3 + edlevel4, data=rwm1984)
summary(nb1)
# NB1
library(gamlss)
summary(gamlss(formula = docvis ~ outwork + age + married + female +  
    edlevel2 + edlevel3 + edlevel4, family = NBII, data = rwm1984))
# ============================================================


# 5.4.3
# ------

# R CODE 
# POISSON
library(COUNT) ; data(nuts)
nut <- subset(nuts, dbh<.6)
sntrees <- scale(nut$ntrees)
sheight <- scale(nut$height)
scover  <- scale(nut$cover)
summary(PO <- glm(cones ~ sntrees + sheight + scover, family=quasipoisson, data=nut))
table(nut$cones)
summary(nut$cones)

# NEGATIVE BINOMIAL
library(msme)
NB <- nbinomial(cones ~ sntrees + sheight + scover, data=nut)
summary(NB)

# HETEROGENEOUS NEGATIVE BINOMIAL
summary(HNB <- nbinomial(cones ~ sntrees + sheight + scover, 
     formula2 =~ sntrees + sheight + scover, data=nut, family = "negBinomial", 
     scale.link = "log_s"))
exp(coef(HNB))


# ===============================================================
#        CHAPTER 6  Poisson Inverse Gaussian Regression
# ===============================================================
#
# 6.2.2
# ------

# Table 6.3  R: Poisson Inverse Gaussian - rwm1984
# ========================================================
library(gamlss); library(COUNT); library(msme); library(sandwich)
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
summary(nbmod <- glm.nb(docvis ~ outwork + age, data=rwm1984))
vcovHC(nbmod)
sqrt(diag(vcovHC(nbmod, type="HC0")))  
pigmod <- gamlss(docvis ~ outwork + age, data=rwm1984, family=PIG)
summary(pigmod)
exp(coef(pigmod))
# =========================================================
exp(1.344)

# Table 6.5  R: Poisson Inverse Gaussian - medpar
# ========================================================
library(gamlss); library(COUNT); library(msme); library(sandwich)
data(medpar)
rwm1984 <- subset(rwm5yr, year==1984)
summary(nbmod1 <- glm.nb(los ~ hmo + white + factor(type), data=medpar))
vcovHC(nbmod1)
sqrt(diag(vcovHC(nbmod1, type="HC0")))  
pigmod1 <- gamlss(los ~ hmo + white + factor(type), data=medpar, family=PIG)
summary(pigmod1)
exp(coef(pigmod1))
# =========================================================


# ===============================================================
#        CHAPTER 7  Probleems with Zero Counts
# ===============================================================
#
# 
# R
# ================================================
exp(-3) * 3^0 / exp(log(factorial(0)))
100* (exp(-3) * 3^0 / exp(log(factorial(0))))
# ================================================

# 7.1.1
# ------

# Table 7.1 R:  Poisson and Zero-truncated Poisson 
# ====================================================
library(msme)
library(gamlss.tr)
data(medpar)
poi <- glm(los ~ white + hmo + factor(type), family=poisson, data=medpar)
summary(poi)
ztp <- gamlss(los ~ white + hmo + factor(type), data=medpar, family="PO")
gen.trun(0, "PO", type="left", name = "lefttr")
lt0poi <- gamlss(los~white+hmo+ factor(type), data=medpar, family="POlefttr")
summary(lt0poi)
# ====================================================

# 7.1.2
# ------

# Table 7.2   Zero-Truncated Negative Binomial
# ==========================================================
library(msme); library(gamlss.tr)
data(medpar)
nb <- nbinomial(los~ white + hmo + factor(type), data=medpar)
summary(nb)
ztnb <- gamlss(los~ white + hmo + factor(type),data=medpar, family="NBI")
gen.trun(0, "NBI", type="left", name = "lefttr")
lt0nb <- gamlss(los~white+hmo+ factor(type), data=medpar, family="NBIlefttr")
summary(lt0nb)
# ==========================================================

# R:  Calculate NB2 expected 0's for given ? and ?
# ==========================================
a <- 1; mu <- 2 ; y <- 0
 exp(y*log(a*mu/(1+a*mu))-(1/a)*log(1+a*mu)+ 
 log(gamma(y +1/a))-log(gamma(y+1))-log( gamma(1/a)))
# ==========================================

# R: Proof that sum of y probabilities from 0 to 100 is 1
# ================================================
a <- 1 ; mu <- 2 ; y <- 0:100
ff <- exp(y*log(a*mu/(1+a*mu))-(1/a)*log(1+a*mu)+ 
 log(gamma(y +1/a))-log(gamma(y+1))-log( gamma(1/a)))  
sum(ff)
# ================================================

# 7.2.1
# ------

# Table 7.3 R:  Poisson-Logit Hurdle
# ====================================================
library(pscl); library(COUNT) 
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
hpl <- hurdle(docvis ~ outwork + age, dist="poisson", data=rwm1984, 
                       zero.dist="binomial", link="logit")
summary(hpl); AIC(hpl)
# ====================================================


# Table 7.4: R Components to Poisson-Logit Hurdle 
# ===================================================
visit <- ifelse(rwm1984$docvis >0, 1, 0)
table(visit)
logis <- glm(visit ~ outwork + age, data=rwm1984, 
                     family=binomial(link="logit"))
summary(logis)
library(pscl)
hpl2 <- hurdle(docvis ~ outwork + age, data=rwm1984,
    dist = "poisson", zero.dist="binomial", link="logit")
summary(hpl2)
logit <- glm(visit ~ outwork + age, data=rwm1984, 
             family=binomial(link="logit"))
summary(logit)
# ===================================================

# Table 7.5 R  NB2-logit Hurdle <Assume Model  from 7.3 Loaded>
# ======================================================
hnbl <- hurdle(docvis ~ outwork + age, dist="poisson", data=rwm1984, 
                       zero.dist="binomial", link="logit")
summary(hnbl); AIC(hnbl)
alpha <- 1/hnbl$theta ; alpha
exp(coef(hnbl))
predhnbl <- hnbl$fitted.values
# ======================================================

# Table 7.6.  R - ZIP
# ====================================================================
library(pscl); library(COUNT)
data(rwm5yr) ; rwm1984 <- subset(rwm5yr, year==1984)
poi <- glm(docvis ~ outwork + age, data=rwm1984, family=poisson)
zip <- zeroinfl(docvis ~ outwork + age | outwork + age, data=rwm1984, dist="poisson")
summary(zip)
print(vuong(zip,poi))
exp(coef(zip))
round(colSums(predict(zip, type="prob")[,1:17]))  # expected counts
rbind(obs=table(rwm1984$docvis)[1:18])            # observed counts
# =================================================================

# 7.3.5
# -----

# R CODE
pred <- round(colSums(predict(zip, type="prob") [,1:13]))
obs <- table(rwm1984$docvis)[1:13]
rbind(obs, pred)

# 7.3.6
# ------

# Table 7.7.  R - ZINB
# ===============================================================
library(pscl); library(COUNT)
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
nb2 <- glm.nb(docvis ~ outwork + age, data=rwm1984)
zinb <- zeroinfl(docvis ~ outwork + age | outwork + age, data=rwm1984, dist="negbin")
summary(zinb)
print(vuong(zinb,nb2))
exp(coef(zinb))
pred <- round(colSums(predict(zinb, type="prob")[,1:13])) # expected counts
obs <- table(rwm1984$docvis)[1:13]                        # observed counts        
rbind(obs, pred)
# ====================================================================

# 7.3.7
# -----

# R  ZIPIG
# ======================================================
library(gamlss) ; data(rwm1984); attach(rwm1984)
zpig <- gamlss(docvis ~ outwork + age, sigma.fo= ~ -1, 
    family="ZIPIG", data=rwm1984)
# summary(zpig) Throws error; uncomment to see
# code for calculating vuong, LR test, etc on book's website
# ======================================================================

# ===============================================================
#        CHAPTER 8  Generalized Poisson
# ===============================================================
# ===============================================================
#        CHAPTER 9  More Advanced Models
# ===============================================================
#
# 9.1  exact models

# R  
# ==============================================
library(COUNT)
data(azcabgptca); attach(azcabgptca)
table(los); table(procedure, type); table(los, procedure)
summary(los)
summary(c91a <- glm(los ~ procedure+ type, family=poisson, data=azcabgptca))
modelfit(c91a)
summary(c91b <- glm(los ~ procedure+ type, family=quasipoisson, data=azcabgptca))
modelfit(c91b)
library(sandwich); sqrt(diag(vcovHC(c91a, type="HC0")))
# ==========================================================

# R
# ==============================================================
library(gamlss.tr)
gen.trun(0,"PO", type="left", name="leftr")
summary(c91c <- gamlss(los~ procedure+type, data=azcabgptca, family="POleftr"))
# ==============================================================================

# 9.2.1  Truncated models
# -----

# Table 9.2 R Left-Truncated at 3 Poisson
# ==================================================
library(COUNT); data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
summary(plt <- gamlss(docvis~outwork + age,data=rwm1984,family="PO"))
library(gamlss); library(gamlss.tr); pltvis<-subset(rwm1984, rwm1984$docvis>3)
summary(ltpo <- gamlss(docvis~outwork+age, family=trun(3, "PO", "left"), data=pltvis))
# -----------------
pltvis<-subset(rwm1984, rwm1984$docvis>3)    # alternative method
gen.trun(3, "PO", "left")                    # saved globally for session
summary(lt3po <- gamlss(docvis~outwork+age, family=POleft, data=pltvis))
# ==================================================

# Table 9.3 R: Right-Truncated Poisson : cut=10
# ==================================================
rtp<-subset(rwm1984, rwm1984$docvis<10)                 
summary(rtpo <- gamlss(docvis~outwork + age, data=rtp, 
   family=trun(10, "PO", type="right"))) # LT, not LE
# ==================================================


# 9.2.2
# ------

# Table 9.4 R  Left Censored Poisson at Cut=3
# =================================================
library(gamlss.cens); library(survival); library(COUNT)
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
lcvis <- rwm1984
cy <- with(lcvis, ifelse(docvis<3, 3, docvis))  
ci <- with(lcvis, ifelse(docvis<=3, 0, 1))
Surv(cy,ci, type="left")[1:100]
cbind(Surv(cy,ci, type="left")[1:50], rwm1984$docvis[1:50])
lcmdvis <- data.frame(lcvis, cy, ci )
rm(cy,ci); gen.cens("PO",type="left")
lcat30<-gamlss(Surv(cy, ci, type="left") ~ outwork + age, 
    data=lcmdvis, family=POlc)
summary(lcat30)
# ================================================


# Table 9.5 R Right censored Poisson at 10
# =========================================
library(gamlss.cens); library(survival); rcvis <- rwm1984 
cy <- with(rcvis, ifelse(docvis>=10, 9, docvis)) 
ci <- with(rcvis, ifelse(docvis>=10, 0, 1)) 
rcvis <- data.frame(rcvis, cy, ci ) 
rm(cy,ci) ; gen.cens("PO",type="right") 
summary(rcat30<-gamlss(Surv(cy, ci) ~ outwork + age, 
   data=rcvis, family=POrc, n.cyc=100)) 
# ==========================================

# 9.3
# ------

# Table 9.6 R: Poisson-Poisson Finite Mixture Model
# =================================================
library(COUNT)
library(flexmix)
data(fishing)
attach(fishing)
## FIXME the following code gives an error that the model argument should
## be one of "gaussian", "binomial", "poisson", "Gamma" 

fmm_pg <- flexmix(totabund~meandepth + offset(log(sweptarea)),
                  data=rwm1984, k=2,
                  model=list(FLXMRglm(totabund~., family="poisson"),
                    FLXMRglm(totabund~., family="poisson")))
parameters(fmm_pg, component=1, model=1)
parameters(fmm_pg, component=2, model=1)
summary(fmm_pg)

# =================================================

# 9.4
# ------

#Table 9.7 R: GAM 
# ===========================================================
library(COUNT); library(mgcv)
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
summary(pglm <- glm(docvis ~ outwork + age + female + married + 
     edlevel2 + edlevel3 + edlevel4, family=poisson, data=rwm1984))
summary(pgam <- gam(docvis ~ outwork + s(age) + female + married + 
     edlevel2 + edlevel3 + edlevel4, family=poisson, data=rwm1984))
plot(pgam)
# ===========================================================

# 9.6.1
#-----

# Table 9.8 R: GEE
# ================================================
library(COUNT); library(gee); data(medpar)
summary(pgee <- gee(los ~ hmo + white + age80 + type2 + type3, 
                  data=medpar,   id=medpar$provnum,
                  corstr='exchangeable', family=poisson))
# =============================================

# 9.6.2
# -----

# Table 9.9 R  Random Intercept Poisson
# ================================================
library(gamlss.mx)
summary(rip <- gamlssNP(los ~ hmo + white + type2 + type3, 
                          random=~1|provnum, data=medpar, 
                          family="PO", mixture="gq", K=20))
# ================================================

# 9.7
# ----

# Table 9.10  R  Generalized Waring Regression
# ========================================================
library(COUNT); library(GWRM)  
data(rwm5yr); rwm1984 <- subset(rwm5yr, year==1984)
war <- GWRM.fit(docvis ~ outwork + age + female + married, data=rwm1984)
GWRM.display(war)
# =========================================================

# 9.8
# ----

# Table 9.11 R: Bayesian Poisson  MCMC
# ======================================================
library(COUNT); library(MCMCpack); data(medpar)
summary(poi <- glm(los ~ hmo + white + type2 + type3, 
                   family=poisson, data=medpar))
confint.default(poi)
summary(poibayes <- MCMCpoisson(los ~ hmo + white + type2 + type3,
                burnin = 5000, mcmc = 100000, data=medpar))
# ======================================================

# nbr2_6_2_3.r  Chanages to multivariable models
# Table 6.7  Hilbe,JM (2011), Negative Binomial Regression, 2 ed, Cambridge Univ Press
nobs <- 50000
x1m <- runif(nobs)
ym <-rpois(nobs, exp(1 + 0.5*x1 -.25*x2))
poim <- glm(ym ~ x1 + x2, family=poisson)
summary(poim)
mum <- predict(poim, type="response")
# change response ym
ym10 <- ym*10
poim10 <- glm(ym10 ~ x1 + x2, family=poisson)
summary(poim10)
mum10 <- predict(poim10, type="response")
# change predictor x1
xm10 <- x1*10
poix10 <- glm(ym ~ xm10 + x2, family=poisson)
summary(poix10)
mumx10 <- predict(poix10, type="response")

# syn.nb1.r     Synthetic NB1 regression
# Table 10.6: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
# Synthetic NB1 regression   amend as needed
#
library(MASS)     
library(gamlss)
nobs <- 50000
x1 <- runif(nobs)
x2 <- runif(nobs)
xb <-  0.5 + 1.25*x1 - 1.5*x2     
delta <- .5      # value assigned to delta
exb <-exp(xb)
idelta <- (1/delta)*exb    
xg <-rgamma(n = 50000, shape = idelta, rate = idelta)
xbg <- exb*xg
nb1y <- rpois(50000, xbg)
jhgm <- gamlss(nbly ~ x1 + x2,family=NBII)
summary(jhgm)
# nb1 <- ml.nb1(los ~ hmo + white + type) # Table 10.8
# nb1

# hilbe.NBR2.F8.8.r
# Negative binomial regression distributions with 
#    user specified series of alpha values for a specified mean value
# From Hilbe, Negative Binomial regression, 2nd ed, Cambridge Univ. Press
# Figures 8.8   default: alpha at 0, .33, .67, 1, 1.5, 3 and mean=1
#
obs <- 11
alpha <- c(.009, .33, .67, 1, 1.5, 3)
y <- 0:10
mu <- 1
amu <- mu*alpha
layout(1) 
for (i in 1:length(amu)) { 
ynb2 = exp(
        y*log(amu[i]/(1+amu[i])) 
     - (1/alpha[i])*log(1+amu[i]) 
     + log( gamma(y +1/alpha[i]) )
     - log( gamma(y+1) ) 
     - log( gamma(1/alpha[i]) ) 
)
if (i==1) { 
plot(y, ynb2, col=i, type='l', lty=i) 
  } else { 
  lines(y, ynb2, col=i, lty=i) 
  } 
}

# myTable.r - Frequency count and percentage table
# Table 9.40 :  Hilbe, JM (2011) Negative Binomial Regression, 2nd ed, Cambridge Univ Press
library(MASS)

# load("c://source/mdvis.RData")
# numvisit <- mdvis$numvisit
myTable <- function(x) { 
myDF <- data.frame( table(x) ) 
myDF$Prop <- prop.table( myDF$Freq ) 
myDF$CumProp <- cumsum( myDF$Prop ) 
myDF 
} 
# myTable(numvisit) 

# syn.probit.r     Synthetic probit regression
# Table 9.21: Hilbe, Negative Binomial Regression, 2 ed, Cambridge Univ Press 
library(MASS)
nobs <- 50000                           
x1 <- runif(nobs)                       
x2 <- runif(nobs)                       
xb <- 2 + .75*x1 - 1.25*x2                  
exb <- pnorm(xb)
by  <- rbinom(nobs, size = 1, prob =exb)
pry <- glm(by ~ x1 + x2, family=binomial(link="probit"))
summary(pry)
